/*
 *
 * Written By:   James "Bo" Begole
 * Date:         Feb 20 1997
 * Description:  Consumer for a channel that recieves block and plane control 
 *                   event messages.
 *                   These messages will be converted to calls to a
 *                   BlockAndPlane object.
 *
 * $Header: /home/nie/cvsroot/prototype/vt/cs/virtSchool/client/RoomView.java,v
1.1 1996/12/13 21:43:54 begolej Exp $
 *
 * Copyright (c) 1996 James Bo Begole
 * Copyright (c) 1996 Virginia Polytechnic University and State University
 */
 
package sieve.crew;

import sieve.quarry.*;
import java.util.*;
import java.awt.*;

public class LinkInfo  implements java.io.Serializable {
    String identifier = null;
    String sourceNuggetId = null;
    String destNuggetId = null;

    private static Hashtable objIndex = new Hashtable();
    private static Hashtable idIndex = new Hashtable();

    public static LinkInfo getLinkInfo(Link link) {
	return getLinkInfo(link.getSource().getBean(), 
	    link.getDest().getBean());
    }

    public static LinkInfo getLinkInfo(Object srcNugget, Object destNugget) {
	LinkRecord lr = new LinkRecord(srcNugget, destNugget);
	LinkInfo li = (LinkInfo)objIndex.get(lr);
	if (li == null) {
      	    li = new LinkInfo(srcNugget, destNugget,
               "id:"+System.currentTimeMillis());  // should prepend hostname 
      	    registerLinkInfo(lr, li);
	}
	return li;
    }

    public static void registerLinkInfo(Link link, LinkInfo li) {
	LinkRecord lr = new LinkRecord(link.getSource().getBean(),
	    link.getDest().getBean());
	registerLinkInfo(lr, li);
    }

    protected static void registerLinkInfo(LinkRecord link, LinkInfo li) {
        objIndex.put(link, li);
    	idIndex.put(li.getIdentifier(), li);
    }

    public static LinkInfo getLinkInfo(String identifier){
    	return (LinkInfo)idIndex.get(identifier);
    }

    private LinkInfo(Object srcNugget, Object destNugget, String identifier) {
    	this.identifier = identifier;
    	this.sourceNuggetId = 
		NuggetInfo.getNuggetInfo(srcNugget).getIdentifier();
    	this.destNuggetId = 
		NuggetInfo.getNuggetInfo(destNugget).getIdentifier();
    }

    private LinkInfo(Link link, String identifier) {
	this (link.getSource().getBean(), link.getDest().getBean(), 
	    identifier);
    }
  
    public void setSourceIdentifier(String sourceNuggetId) {
      	this.sourceNuggetId = sourceNuggetId;
    }
    public String getSourceIdentifier() {
      	return sourceNuggetId;
    }
    public void setDestIdentifier(String destNuggetId) {
    	this.destNuggetId = destNuggetId;
    }
    public String getDestIdentifier() {
    	return destNuggetId;
    }
    public String getIdentifier() {
    	return identifier;
    }
    public void setIdentifier(String identifier) {
    	this.identifier = identifier;
    }

    public Link getLink() {
//    return link;
return null;
    }
    public void setLink(Link link) {
//    this.link = link;
    }

    public String toString(){
    	String parmString = " Identifier = "+identifier+
           " sourceNuggetId="+sourceNuggetId+" destNuggetId="+destNuggetId;
     	return "["+getClass().getName()+":"+parmString+"]";
    }
}

class LinkRecord {
    Object sourceBean = null;
    Object destBean = null;
 
    public LinkRecord(Object sourceBean, Object destBean) {
        this.sourceBean = sourceBean;
        this.destBean = destBean;
    }
}

