/*
 *
 * Written By:   Philip Isenhour
 * Date:         Mar 03 1997
 * Description:  Contains description of a Nugget property change.
 *
 * $Header: /home/nie/cvsroot/prototype/vt/cs/virtSchool/client/RoomView.java,v
1.1 1996/12/13 21:43:54 begolej Exp $
 *
 * Copyright (c) 1996 Philip Isenhour
 * Copyright (c) 1996 Virginia Polytechnic University and State University
 */
 
package sieve.crew;

import sieve.quarry.*;
import java.awt.Rectangle;
import java.util.Hashtable;
import java.io.*;

/**
 * Container of information to change a property of a bean (nugget).
 * @version $Revision: 1.1 $
 */
public class NuggetChangeInfo implements java.io.Serializable {
  String identifier = null;
  String property   = null;
  Object newValue   = null;
  transient Object nugget = null;
  transient NuggetInfo nuggetInfo = null;

  public NuggetChangeInfo( Object nugget, 
			String property,
			Object newValue) {
    this.nugget = nugget;
    this.nuggetInfo = nuggetInfo = NuggetInfo.getNuggetInfo(nugget);
    this.identifier = nuggetInfo.getIdentifier();
    this.property = property;
    this.newValue = newValue;
  }

  public Object getNugget() {
    return nugget;
  }
  public void setNugget(Object nugget) {
    this.nugget = nugget;
  }

  public String getIdentifier() {
    return identifier;
  }
  public void setIdentifier(String identifier) {
    this.identifier = identifier;
  }

  public String getProperty() {
    return property;
  }
  public void setProperty(String property) {
    this.property = property;
  }

  public Object getNewValue() {
    return newValue;
  }
  public void setNewValue(Object newValue) {
    this.newValue = newValue;
  }

  public NuggetInfo getNuggetInfo() {
    return nuggetInfo;
  }
  public void setNuggetInfo(NuggetInfo nuggetInfo) {
    this.nuggetInfo = nuggetInfo;
  }

  public String toString(){
    String parmString = " Identifier = "+identifier+
       " Property = " + property+
       " New Value = " + newValue;
    return "["+getClass().getName()+":"+parmString+"]";
  }

  private void readObject(ObjectInputStream in) throws IOException {
    try {
      in.defaultReadObject();
    }
    catch (ClassNotFoundException e) {
      e.printStackTrace();
    }
    nuggetInfo = NuggetInfo.getNuggetInfo(identifier);
    nugget = nuggetInfo.getNugget();
  }

  private static  final boolean debug = false;
  private void debug(String msg) {
    if (debug)
      System.out.println(getClass().getName()+": "+msg);
  }
}
