package sieve.nuggets;
 
import java.awt.*;
import java.awt.event.*;
import sieve.sluice.*;
import java.util.*;

public class MMMQuizHistogram extends Histogram implements MouseListener {

    NamedBin selection = null;

    public MMMQuizHistogram() {
	super();
    }

/*
    public void setShowMeanMedianMode(boolean set) {
	showMeanMedianMode = false;
    }
*/

    public synchronized void clearSelection() {
	if (selection != null) {
	    namedBins.removeElement(selection);
	    selection = null;
	    offScreen = null;
	    repaint();
	}
    }

    public void setFields(String labelField, String freqField) {
	clearSelection();
	super.setFields(labelField, freqField);
    }

    public void tableViewChanged(TableViewEvent event) {
	clearSelection();
	super.tableViewChanged(event);
    }

    /**
     * Overriding to force mousePressed to be ignored.
     */
    public void mousePressed(MouseEvent e) { 
    }

    public void mouseReleased(MouseEvent e) {
	if ((mouseColumn >= 0) && (mouseColumn < columns) && 
	    (namedBins != null)) {
	    if (selection != null)
	        namedBins.removeElement(selection);
	    selection = new NamedBin("My guess", mouseColumn, Color.red);
	    insertNamedBin(namedBins, selection);
	    repaint();
	}
    }

}

