package sieve.nuggets.kit;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**
 * A GridLine draws a line across the chart at a given 
 * data point.
 */
public abstract class GridLine implements VisualizationElement {
    private Object vObj = null;
    protected Axis vAxis = null;
    protected Axis hAxis = null;

    private Color lineColor = Color.gray;

    public GridLine(Object dataPoint) {
	this.vObj = dataPoint;
    }

    protected Object getDataPoint() {
	return vObj;
    }

    /**
     * Returns the color in which lines are drawn.
     */
    public Color getLineColor() {
	return lineColor;
    }

    /**
     * Sets the color in which lines are drawn.
     */
    public void setLineColor(Color c) {
	lineColor = c;
    }

    // ---------------    VisualizationElement methods    ---------------
    public void setVerticalAxis(Axis a) {
	vAxis = a;
    }
    public void setHorizontalAxis(Axis a) {
	hAxis = a;
    }

    public abstract void paint(Graphics g);

    public abstract boolean contains(int x, int y);

}


