package sieve.nuggets.kit;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**
 * A HorizontalGridLine draws a line across the chart at a given 
 * data point.
 */
public class HorizontalGridLine extends GridLine implements 
    VisualizationElement {

    public HorizontalGridLine(Object dataPoint) {
	super(dataPoint);
    }

    public void paint(Graphics g) {
	int startX = hAxis.getFirstPixel();
	int endX = hAxis.getLastPixel();
	int y = vAxis.getCentralPixel(getDataPoint());
	if (y >= 0) {
	    g.setColor(getLineColor());
	    g.drawLine(startX, y, endX, y);
	}
    }

    public boolean contains(int x, int y) {
	return false;
    }

}


