package sieve.nuggets.kit;

import java.awt.*;

public class SimpleHorizontalAxis implements Axis {
    private Component parent = null;
    private Rectangle bounds = null;
    private DataDistributor distributor = null;

    public SimpleHorizontalAxis(Component parent, DataDistributor distributor) {
	this.parent = parent;
	this.distributor = distributor;
    }

    protected Component getParent() {
	return parent;
    }
    public Rectangle getBounds() {
	return bounds;
    }
    protected DataDistributor getDataDistributor() {
	return distributor;
    }

    public int getFirstPixel() {
	if (bounds == null)
	    return 0;
	else
	    return bounds.x;
    }

    public int getLastPixel() {
	if (bounds == null)
	    //return parent.getSize().width;
	    return parent.size().width;
	else
	    return bounds.x + bounds.width;
    }

    public Dimension getPreferredSize() {
	//return new Dimension(parent.getSize().width, 1);
	return new Dimension(parent.size().width, 1);
    }

    public void setBounds(Rectangle bounds) {
	this.bounds = bounds;
	distributor.setSize(bounds.width);
    }

    public int getMaxSize(Object dataPoint) {
	return distributor.getMaxSize(dataPoint);
    }

    public int getCentralPixel(Object dataPoint) {
	return getFirstPixel() + distributor.getCentralPixel(dataPoint);
    }

    public Object getDataPoint(int pixel) {
	return distributor.getDataPoint(pixel - getFirstPixel());
    }

    public void paint(Graphics g) {
	if (bounds != null) {
	    g.setColor(Color.black);
	    g.drawLine(bounds.x, bounds.y, bounds.x + bounds.width, bounds.y);
	}
    }

}

