package sieve.phys.blockandplane;
import java.awt.*;
import java.lang.Float;

public class MovingBodyDialog extends Dialog {

Button Cancel = new Button("Cancel");
Button Ok	    = new Button("Ok");
Block block   = null;
Label HeightLabel      = null;
TextField HeightField  = null;
Label LengthLabel      = null;
TextField LengthField  = null;
BlockAndPlane bnp = null;

public MovingBodyDialog(Block b, Frame parentFrame, BlockAndPlane bnp) {
   super(parentFrame, "Parameters", false);
   this.bnp = bnp;
   block = b;   
   Panel p1 = new Panel();
   p1.setLayout(new GridLayout(0,2));
   // Height
   HeightLabel = new Label("Height: (m) ",Label.LEFT);
   Float f = new Float(block.getHeight());
   HeightField = new TextField(f.toString(),10);
   p1.add(HeightLabel);
   p1.add(HeightField);
   // Length
   LengthLabel = new Label("Length: (m) ",Label.LEFT);
   f = new Float(block.getLength());
   LengthField = new TextField(f.toString(),10);
   p1.add(LengthLabel);
   p1.add(LengthField);

   p1.add(Ok);
   p1.add(Cancel);

   setLayout(new GridLayout(0,1));
   add(p1);   
   
   //Initialize this dialog to its preferred size.
   pack();
}
public boolean action(Event event, Object arg) {

   if (event.target == Cancel){
      bnp.refresh();
   	 hide();
      return true;
    }
   if (event.target == Ok) {
      block.setLength((Float.valueOf(LengthField.getText())).floatValue());
      block.setHeight((Float.valueOf(HeightField.getText())).floatValue());
      hide();
      block.reset();
      bnp.refresh();
      return true;
   } 
   return false; 
}
}
