package sieve.phys.bnp2;

import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import com.sun.java.swing.*;
import java.lang.Float;

public class DataCollectDialog extends JFrame implements ActionListener, java.io.Serializable {

  JButton Cancel = new JButton("Cancel");
  JButton Ok	    = new JButton("Ok");
  Block block   = null;
  JLabel TimeStepLabel      = null;
  JTextField TimeStepField  = null;
  BlockAndPlane bnp = null;

public DataCollectDialog(Frame parentFrame, BlockAndPlane bnp) {
  // super(parentFrame, "Change Constants", false);
   super("Change Constants");
   this.bnp = bnp;
   JPanel p1 = new JPanel();
   p1.setLayout(new GridLayout(0,2));
   // Gravity
   TimeStepLabel = new JLabel("Time Step: (s) ");
   Float f = new Float(bnp.getTimeStep());
   TimeStepField = new JTextField(f.toString(),10);
   p1.add(TimeStepLabel);
   p1.add(TimeStepField);

   p1.add(Ok);
   p1.add(Cancel);
   Ok.addActionListener(this);
   Cancel.addActionListener(this);

   getContentPane().setLayout(new GridLayout(0,1));
   getContentPane().add(p1);   
      
   //Initialize this dialog to its preferred size.
   pack();
}
  public void actionPerformed(ActionEvent e) {
    Object target = e.getSource();

   if (target == Cancel){
   	 hide();
   	 bnp.refresh();
      return;
    }
   if (target == Ok) {
   	 // Enforce minimum timestep value
      if (((Float.valueOf(TimeStepField.getText())).floatValue()) >= 0.01)
         bnp.setTimeStep((Float.valueOf(TimeStepField.getText())).floatValue());
      else 
         bnp.setTimeStep((float)0.01);
      hide();
      bnp.refresh();
      return;
   } 
   return; 
}
}
