package sieve.phys.bnp2;

import java.awt.GridLayout;
import java.awt.Frame;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import com.sun.java.swing.*;
import java.lang.Float;

public class FloorDialog extends JFrame implements ActionListener, java.io.Serializable  {

  JButton Cancel = new JButton("Cancel");
  JButton Ok	    = new JButton("Ok");
  Plane  plane  = null;
  JLabel LengthLabel      = null;
  JTextField LengthField  = null;
  JLabel MuSLabel         = null;
  JTextField MuSField     = null;
  JLabel MuKLabel         = null;
  JTextField MuKField     = null;
  BlockAndPlane bnp = null;

public FloorDialog(Plane p, Frame parentFrame, BlockAndPlane bnp) {
  //   super(parentFrame, "Change Floor Parameters", false);
   super("Change Floor Parameters");
   this.bnp = bnp;
   plane = p;   
   JPanel p1 = new JPanel();
   p1.setLayout(new GridLayout(0,2));
   // Length
   LengthLabel = new JLabel("Length: (m) ");
   Float f = new Float(plane.getLength());
   LengthField = new JTextField(f.toString(),10);
   p1.add(LengthLabel);
   p1.add(LengthField);
   // MuS
   MuSLabel = new JLabel("MuS: ");
   f = new Float(plane.getMuS());
   MuSField = new JTextField(f.toString(),10);
   p1.add(MuSLabel);
   p1.add(MuSField);
   // MuK
   MuKLabel = new JLabel("MuK: ");
   f = new Float(plane.getMuK());
   MuKField = new JTextField(f.toString(),10);
   p1.add(MuKLabel);
   p1.add(MuKField);

   p1.add(Ok);
   p1.add(Cancel);
   
   Ok.addActionListener(this);
   Cancel.addActionListener(this);

   getContentPane().setLayout(new GridLayout(0,1));
   getContentPane().add(p1);   
   
   //Initialize this dialog to its preferred size.
   pack();
}
  public void actionPerformed(ActionEvent e) {
    Object target = e.getSource();
    Float f1 = null,f2 = null;
    Double d = null;
   if (target == Cancel){
      bnp.refresh();
   	 hide();
      return ;
    }
   if (target == Ok) {
      plane.setLength((Float.valueOf(LengthField.getText())).floatValue());
      plane.setMuS((Float.valueOf(MuSField.getText())).floatValue());
      plane.setMuK((Float.valueOf(MuKField.getText())).floatValue());
      hide();
      bnp.refresh();
      return ;
   } 
}
} 
