package sieve.phys.circuit;
import java.awt.*;
import java.lang.Math;
 
public class Ammeter extends CircuitComponent {
        private double Ohms; 
        private double Amps;
        private Math power;
 
Ammeter(int SetID){
        ComponentID = SetID;
        Ohms = power.pow(10, -14);
}
 
Ammeter(){
        ComponentID = -1;
        Ohms = power.pow(10, -14);
}

public void setAmps(double Amp){
     	Amps = Amp+0.0005; 
        this.repaint();
}
 public void layout() {
       if (Orientation)
        {
        Dimension pref = t1.getPreferredSize();
        t1.setBounds(2, (40 - pref.height)/2, pref.width, pref.height);
        pref = t2.getPreferredSize();
        t2.setBounds(98 - pref.width, (40 - pref.height)/2, pref.width,
            pref.height);
        setSize(100,40);
        }
      else
        {
         Dimension pref = t1.getPreferredSize();
        t1.setBounds((50 - pref.width)/2, 2, pref.width, pref.height);
        pref = t2.getPreferredSize();
        t2.setBounds((50 - pref.width)/2 , 68 - pref.height, pref.width, pref.height);
        setSize(50,70);
        }
        
    }
 
    public Dimension getPreferredSize() {
       if (Orientation)
        return new Dimension(100,40);
        else
        return new Dimension(50,70);
 
 
    }
 public Dimension getMinimumSize() {
        if (Orientation)
        return new Dimension(100,40);
        else
        return new Dimension(50,70);
 
 
    }

public void paint(Graphics g) {
        Rectangle t1Bounds = t1.getBounds();
        Rectangle t2Bounds = t2.getBounds();
        if (selected || red)
            g.setColor(Color.red);
        else    g.setColor(Color.black);
	int y = t1Bounds.y + t1Bounds.height/2;
        Dimension maxdim=getPreferredSize();
 
        int x = t1Bounds.x +t1Bounds.width;
        int w = t2Bounds.x-x;
        int h=20;
 
        int pt1, pt2, pt3, pt4, pt5, pt6, pt7, pt8, pt9,Sheight, Swidth;
        if (Orientation)
{ 
         pt1=x+w/6;
        pt4 =x+w*5/6;
        pt2 =pt1+(pt4-pt1)/3;
        pt3 =pt1+(pt4-pt1)*2/3;
	
        g.drawLine(x, y, pt1, y);
 
   //     g.drawOval(pt1, y-(pt4-pt1)/2 ,pt4-pt1,pt4-pt1 );
        g.drawOval(pt1, y-(maxdim.height)/2 ,pt4-pt1, maxdim.height-2 );
        g.drawLine(pt4, y, x+w, y);
	FontMetrics fm = g.getFontMetrics();
        if(Amps<1.0 && Amps >-1.0)
        {   // display Milli Amps
             StringBuffer ampBuffer= new StringBuffer();
            String ampString=  Integer.toString((new Double(Amps*1000)).intValue());
	    ampBuffer.append(ampString);
            ampBuffer.append("mA");
            String DisplayStr=ampBuffer.toString(); 
            Sheight=fm.getHeight();
	    Swidth=fm.stringWidth(DisplayStr);
            g.drawString(DisplayStr, x+(w-Swidth)/2,y+Sheight/2);
        }
        else 
        {   // display  Amps
            StringBuffer ampBuffer= new StringBuffer();
            String ampString=  Integer.toString((new Double(Amps)).intValue());
	    ampBuffer.append(ampString);
            ampBuffer.append("A");
            String DisplayStr=ampBuffer.toString(); 
            Sheight=fm.getHeight();
	    Swidth=fm.stringWidth(DisplayStr);
            g.drawString(DisplayStr, x+(w-Swidth)/2,y+Sheight/2);
         }
        g.fillRect(t1Bounds.x, t1Bounds.y, t1Bounds.width, t1Bounds.height);
        g.fillRect(t2Bounds.x, t2Bounds.y, t2Bounds.width, t2Bounds.height);
}
      else if (!Orientation)
      {
       x=t1Bounds.x+t1Bounds.width/2;
          w=maxdim.width;
          y=t1Bounds.y+t1Bounds.height;
          h=t2Bounds.y-t1Bounds.y;
          pt1=y+h/12;
          pt4 =y+h*8/12;
          pt2 =pt1+(pt4-pt1)/3;
          pt3 =pt1+(pt4-pt1)*2/3;
          g.drawLine(x, y, x, pt1);
         // g.drawOval(x-(pt4-pt1)/2,pt1 ,pt4-pt1,pt4-pt1 );
          g.drawOval(x-(maxdim.width-2)/2,pt1 ,maxdim.width-2,pt4-pt1 );
        FontMetrics fm = g.getFontMetrics();
        if(Amps<1.0 && Amps >-1.0)
        {   // display Milli Amps
             StringBuffer ampBuffer= new StringBuffer();
            String ampString=  Integer.toString((new Double(Amps*1000)).intValue());
	    ampBuffer.append(ampString);
            ampBuffer.append("mA");
            String DisplayStr=ampBuffer.toString(); 
            Sheight=fm.getHeight();
	    Swidth=fm.stringWidth(DisplayStr);
            g.drawString(DisplayStr, (w-Swidth)/2, (maxdim.height)/2);
        }
        else 
        {   // display  Amps
            StringBuffer ampBuffer= new StringBuffer();
            String ampString=  Integer.toString((new Double(Amps)).intValue());
	    ampBuffer.append(ampString);
            ampBuffer.append("A");
            String DisplayStr=ampBuffer.toString(); 
            Sheight=fm.getHeight();
	    Swidth=fm.stringWidth(DisplayStr);
            g.drawString(DisplayStr, (w-Swidth)/2, (maxdim.height)/2);
         }
         g.drawLine(x,pt4,x,y+h);
         g.fillRect(t1Bounds.x, t1Bounds.y, t1Bounds.width, t1Bounds.height);

        g.fillRect(t2Bounds.x, t2Bounds.y, t2Bounds.width, t2Bounds.height);

      }
        super.paint(g);
    }
 
 
}

