package sieve.phys.circuit;

import java.beans.*;
import java.awt.*;

/**
 * This class provides info about which properties of the Battery class
 * should be made editable.
 */
public class BatteryBeanInfo extends SimpleBeanInfo {

    public BeanDescriptor getBeanDescriptor() {
        BeanDescriptor bd = new BeanDescriptor(Battery.class);
        bd.setDisplayName("Battery");
        return bd;
    }

    public PropertyDescriptor[] getPropertyDescriptors() {
        PropertyDescriptor[] myProps = new PropertyDescriptor[5];
        try {
            myProps[0] = new PropertyDescriptor("Voltage", Battery.class);
            myProps[1] = new PropertyDescriptor("Node1", Battery.class);
            myProps[2] = new PropertyDescriptor("Node2", Battery.class);
            myProps[3] = new PropertyDescriptor("Direction", Battery.class);
            myProps[4] = new PropertyDescriptor("Orientation", Battery.class);
        }
        catch(Exception e) {
            e.printStackTrace();
        }
        return myProps;
    }
}

