package sieve.phys.circuit;
 
import java.awt.*;
import java.awt.event.*;
import sieve.workbench.*;
import sieve.workbench.event.*;
import java.io.InputStreamReader.*;
import java.io.*;

public class Palette extends Container implements MouseListener {
    private Workbench wb = null;
    private CircuitComponentTool tool = null;
    private int ResistorCount;
    private int BatteryCount;
    private int VoltmeterCount;
    private int AmmeterCount;
    private int LightBulbCount;
    private int NodeCount;
    private boolean listenerNotSet=true; 
    private FileReader infile;

    public Palette() {
	this("testfile2");
    }

    public Palette(String filename) {
           int test;
           String thisLine;
  //Open the file for reading
  try {
    FileInputStream fin =  new FileInputStream(filename);

    // now turn the FileInputStream into a DataInputStream
    try {
      DataInputStream myInput = new DataInputStream(fin);
  
      try {
           thisLine = myInput.readLine(); 
           // ignore the first line - it it the name of the palette
           thisLine = myInput.readLine(); 
           test = Integer.valueOf(thisLine).intValue();
           ResistorCount=test; 
           thisLine = myInput.readLine(); 
           test = Integer.valueOf(thisLine).intValue();
    	   BatteryCount=test;
           thisLine = myInput.readLine(); 
           test = Integer.valueOf(thisLine).intValue();
    	   LightBulbCount=test;
           thisLine = myInput.readLine(); 
           test = Integer.valueOf(thisLine).intValue();
    	   AmmeterCount=test;
           thisLine = myInput.readLine(); 
           test = Integer.valueOf(thisLine).intValue();
    	   VoltmeterCount=test;
           thisLine = myInput.readLine(); 
           test = Integer.valueOf(thisLine).intValue();
    	   NodeCount=test;
      }
      catch (Exception e) {
        ResistorCount=5; 
    	BatteryCount=5;
    	VoltmeterCount=5;
    	AmmeterCount=5;
    	LightBulbCount=5;
    	NodeCount=5;
      }
    } // end try
    catch (Exception e) {
        ResistorCount=5; 
    	BatteryCount=5;
    	VoltmeterCount=5;
    	AmmeterCount=5;
    	LightBulbCount=5;
    	NodeCount=5;
    }
  
   } // end try
   catch (Exception e) {
        ResistorCount=5; 
    	BatteryCount=5;
    	VoltmeterCount=5;
    	AmmeterCount=5;
    	LightBulbCount=5;
    	NodeCount=5;
  }
 addMouseListener(this);
 }
    private class Listener extends WorkbenchListenerAdapter {
        private Palette palette=null;        
        public Listener (Palette p) {
         palette=p;
        }       
        public void componentAdded(WorkbenchComponentEvent e) {
               WorkbenchComponent wbc = e.getWorkbenchComponent();
            if (wbc instanceof Resistor && !(wbc instanceof Voltmeter) && !(wbc instanceof Ammeter))
                 palette.ResistorCount=palette.ResistorCount-1;
            else if (wbc instanceof Battery)
                  palette.BatteryCount=palette.BatteryCount-1;
           else if (wbc instanceof Voltmeter)
                 palette.VoltmeterCount=palette.VoltmeterCount-1;
            else if (wbc instanceof Ammeter)
                 palette.AmmeterCount=palette.AmmeterCount-1;
            else if (wbc instanceof LightBulb)
                 palette.LightBulbCount=palette.LightBulbCount-1;
            else if (wbc instanceof Nodes)
                 palette.NodeCount=palette.NodeCount-1;
	}
        public void componentRemoved(WorkbenchComponentEvent e) {
               WorkbenchComponent wbc = e.getWorkbenchComponent();
            if (wbc instanceof Resistor && !(wbc instanceof Voltmeter) && !(wbc instanceof Ammeter))
                 palette.ResistorCount=palette.ResistorCount+1;
            else if (wbc instanceof Battery)
                 palette.BatteryCount=palette.BatteryCount+1;
            else if (wbc instanceof Voltmeter)
                 palette.VoltmeterCount=palette.VoltmeterCount+1;
            else if (wbc instanceof Ammeter)
                 palette.AmmeterCount=palette.AmmeterCount+1;
            else if (wbc instanceof LightBulb)
                 palette.LightBulbCount=palette.LightBulbCount+1;
            else if (wbc instanceof Nodes)
                 palette.NodeCount=palette.NodeCount+1;
	}
      }

    public void mousePressed(MouseEvent e) {
     Rectangle border =getBounds();
	if (wb == null) {
	    Component parent = this;
	    while (parent != null && wb == null) {
		if (parent instanceof Workbench)
		    wb = (Workbench) parent;
		parent = parent.getParent();
	    }
        if(listenerNotSet)
          {
          listenerNotSet=false;
          wb.addWorkbenchListener(new Listener(this)); 

	  }
	}
	
        Point p=e.getPoint();
        if (p.y<border.height/2)
        { 
              if (p.x <border.width/3 && ResistorCount>0)
              {   tool = new CircuitComponentTool(wb, Resistor.class);
                        wb.setCurrentTool(tool);
	                addMouseMotionListener(tool);
	                addMouseListener(tool);
              }
              else if (p.x >border.width/3 && p.x <2*border.width/3 && BatteryCount >0)
              {
                        tool = new CircuitComponentTool(wb, Battery.class);
                        wb.setCurrentTool(tool);
	                addMouseMotionListener(tool);
	                addMouseListener(tool);
              }
              else if (p.x > border.width*2/3 && p.x <3*border.width/3 && LightBulbCount>0)
              {
                        tool= new CircuitComponentTool(wb, LightBulb.class);
                        wb.setCurrentTool(tool);
	                addMouseMotionListener(tool);
	                addMouseListener(tool);
              }
              else tool=null;	
        }
        else if (p.y<border.height )
        {
          if (p.x <border.width/3 && AmmeterCount >0)
             {
                 tool = new CircuitComponentTool(wb, Ammeter.class);
                 wb.setCurrentTool(tool);
	         addMouseMotionListener(tool);
	         addMouseListener(tool);
              }
              else if (p.x <2*border.width/3 && p.x >border.width/3 && VoltmeterCount >0)
              {
                 tool = new CircuitComponentTool(wb, Voltmeter.class);
                 wb.setCurrentTool(tool);
	         addMouseMotionListener(tool);
	         addMouseListener(tool);
              }
              else if (p.x <3*border.width/3 && p.x >2* border.width/3 && NodeCount > 0)
              {
                 tool=new CircuitComponentTool(wb, Nodes.class);
                 wb.setCurrentTool(tool);
	         addMouseMotionListener(tool);
	         addMouseListener(tool);
              }
              else tool=null;	

        }
       else tool=null;	
    }

    public void mouseClicked(MouseEvent e) {}
    public void mouseReleased(MouseEvent e) {
      Point p = e.getPoint();
        removeMouseMotionListener(tool);
	removeMouseListener(tool);
         wb.setCurrentTool(null);
        this.repaint();
    }
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}

    public Dimension getPreferredSize() {
        return new Dimension(240,140);
    }
 
    public Dimension getMinimumSize() {
        return new Dimension(240,140);
    }
    
   public void paint(Graphics g) {

   Rectangle border =getBounds();
	g.setColor(Color.black);
 
 //  g.drawRect(border.x,border.y,border.width,border.height);
   int x,y,w,h;
   int w2,h2;
   x=border.x;
   y=border.y;
   w=border.width;
   h=border.height;
   h2=h/2;
   w2=w/3;
   x=x+w2-5;
   g.drawLine(x,y,x,y+h);
   x=x+w2-5;
   g.drawLine(x,y,x,y+h);
   x=border.x-5;
   y=y+h2-6;
   g.drawLine(x,y,x+w,y);
 /***************************/
 // Draw Resistor
  
   x=border.x;
   y=border.y +35;
   // w=w2;
   //h=h2;
   h=20;
   w=50;
   
     int pt1, pt2, pt3, pt4, pt5, pt6, pt7, pt8, pt9;
          pt1=x+w/3;
          pt5 =x+w/2;
          pt2 =pt1+(pt5-pt1)/4;
          pt4 =pt1+(pt5-pt1)*3/4;
          pt9 =x+w*2/3;
          pt6 =pt5+(pt9-pt5)/4;
          pt8 =pt5+(pt9-pt5)*3/4;
         g.drawLine(x, y, pt1, y);
         g.drawLine(pt1, y , pt2, y+h/2);
         g.drawLine(pt2, y + h/2, pt4, y-h/2);
         g.drawLine(pt4, y - h/2, pt6, y+h/2);
         g.drawLine(pt6, y + h/2, pt8, y-h/2);
         g.drawLine(pt8, y - h/2, pt9, y);
         g.drawLine(pt9, y, x+w, y);
        String Count = Integer.toString(ResistorCount);
         if (ResistorCount<=0)
              g.setColor(Color.red);
         else 
             g.setColor(Color.black);
        g.drawString(Count,border.x,border.y );
             g.setColor(Color.black);
 
 
  //       g.drawLine(border.x+80,border.y,border.x+80,border.y+border.height);

  /****************************/
  // Draw Battery
  
   x= x+w2 ;
        //  x=border.x+80;
          pt1=x+w/3;
          pt4 =x+w*2/3;
          pt2 =pt1+(pt4-pt1)/3;
          pt3 =pt1+(pt4-pt1)*2/3;
 
         g.drawLine(x, y, pt1, y);
         g.drawLine(pt1, y +h/2, pt1, y-h/2);
         g.drawLine(pt2, y +h/4, pt2, y-h/4);
         g.drawLine(pt3, y +h/2, pt3, y-h/2);
         g.drawLine(pt4, y +h/4, pt4, y-h/4);
         g.drawLine(pt4, y, x+w, y);
        Count = Integer.toString(BatteryCount);
         if (BatteryCount<=0)
              g.setColor(Color.red);
         else 
             g.setColor(Color.black);
        g.drawString(Count,border.x+w2,border.y );
             g.setColor(Color.black);
 
   /******************************/
   // Draw LightBulb
     y=border.y +60 ; 
     //y = t1Bounds.y + t1Bounds.height/2;
     h=15;
     //     x=t1Bounds.x+t1Bounds.width;
      //    w=t2Bounds.x-x;
     x=x+w2;
     w=40;
        int Rpt1, Rpt2, Rpt3, Rpt4, Rpt5, Rpt6, Rpt7, Rpt8, Rpt9;
        int Rx,Ry,Rw,Rh;
        pt1=x+w*2/8;
          pt4 =y+h*2/3;
          pt2 =x+w*6/8;
 
 
         g.drawLine(x, y, pt1, y);
         g.drawLine(pt2,y,x+w,y);
         g.drawArc(x,y-4*h,w,h*3,-60,300);
         g.drawLine(pt1,y-h*7/5,pt1, y);
         g.drawLine(pt2,y-h*7/5,pt2, y);
 // here we begin drawing the resistor for inside the light bulb
         Ry = y-h*5/2;
         Rh=h*5/8;
         Rx=pt1;
         Rw=w/2;
          Rpt1=Rx+Rw/3;
          Rpt5 =Rx+Rw/2;
          Rpt2 =Rpt1+(Rpt5-Rpt1)/4;
          Rpt4 =Rpt1+(Rpt5-Rpt1)*3/4;
          Rpt9 =Rx+Rw*2/3;
          Rpt6 =Rpt5+(Rpt9-Rpt5)/4;
          Rpt8 =Rpt5+(Rpt9-Rpt5)*3/4;
         g.drawLine(Rx, Ry, Rpt1, Ry);
         g.drawLine(Rpt1, Ry , Rpt2, Ry+Rh/2);
         g.drawLine(Rpt2, Ry + Rh/2, Rpt4, Ry-Rh/2);
         g.drawLine(Rpt4, Ry - Rh/2, Rpt6, Ry+Rh/2);
         g.drawLine(Rpt6, Ry + Rh/2, Rpt8, Ry-Rh/2);
         g.drawLine(Rpt8, Ry - Rh/2, Rpt9, Ry);
         g.drawLine(Rpt9, Ry, Rx+Rw, Ry);
      y=border.y+40;
      w=50;
  // Next Row
  x=border.x +5;
  y=y +h2;
        Count = Integer.toString(LightBulbCount);
         if (LightBulbCount<=0)
              g.setColor(Color.red);
         else 
             g.setColor(Color.black);
        g.drawString(Count,border.x+w2*2,border.y );
             g.setColor(Color.black);
   
 /**********************************/
 // Draw Ammeter
        int Sheight, Swidth;
        pt1=x+w/6;
        pt4 =x+w*5/6;
        pt2 =pt1+(pt4-pt1)/3;
        pt3 =pt1+(pt4-pt1)*2/3;
 
        g.drawLine(x, y, pt1, y);
        g.drawOval(pt1, y-(pt4-pt1)/2 ,pt4-pt1,pt4-pt1 );
 
        g.drawLine(pt4, y, x+w, y);
        FontMetrics fm = g.getFontMetrics();
        String newampString = "Amps";
        Sheight=fm.getHeight();
        Swidth=fm.stringWidth(newampString);

        g.drawString(newampString, x+(w-Swidth)/2,y+Sheight/2);
        Count = Integer.toString(AmmeterCount);
         if (AmmeterCount<=0)
              g.setColor(Color.red);
         else 
             g.setColor(Color.black);
        g.drawString(Count,border.x,border.y+h2 +2);
             g.setColor(Color.black);
 

 /**********************************/
 // Draw VoltMeter
        x=x+w2;
        pt1=x+w/6;
        pt4 =x+w*5/6;
        pt2 =pt1+(pt4-pt1)/3;
        pt3 =pt1+(pt4-pt1)*2/3;
 
        g.drawLine(x, y, pt1, y);
        g.drawOval(pt1, y-(pt4-pt1)/2 ,pt4-pt1,pt4-pt1 );
 
        g.drawLine(pt4, y, x+w, y);
        fm = g.getFontMetrics();
        String newString = "Volts";
        Sheight=fm.getHeight();
        Swidth=fm.stringWidth(newString);
 
        g.drawString(newString, x+(w-Swidth)/2,y+Sheight/2);
        Count = Integer.toString(VoltmeterCount);
         if (VoltmeterCount<=0)
              g.setColor(Color.red);
         else 
             g.setColor(Color.black);
        g.drawString(Count,border.x+w2,border.y+h2 +2);
             g.setColor(Color.black);
 

 /*********************************/
 // Draw Node ? 
    x=x+w2*3/2;
     g.fillRect(x,y, 10, 10);
 
        Count = Integer.toString(NodeCount);
         if (NodeCount<=0)
              g.setColor(Color.red);
         else 
             g.setColor(Color.black);
        g.drawString(Count,border.x+w2*2,border.y+h2 +2 );
             g.setColor(Color.black);
   

   
   }
 

}

