package sieve.phys.circuit;

import java.awt.*;
import java.io.*;
import java.io.File.*;
import sieve.workbench.*;

public class PaletteToolSet implements ToolSet {
    private String[] labels={"Default"};
    private String[] directList=null;
    private File direct=null;

    /**
     * The name of the ToolSet.
     */
    public String getName() {
	return "Circuit Simulator";
    }
 
    /**
     * The names of all of the tools in the ToolSet.
     */
    public String[] getLabels() {
	// Look for files
        FileInputStream fin =null;
        DataInputStream myInput=null;
        String thisLine=null;
        String filename=null; 
        try{
           direct=new File("CirFiles");
           try {
        	directList= direct.list(); 
        	int Size=directList.length;
                labels=new String[Size+1];
                labels[0]=new String("Default");
       		for (int i=0; i<Size;i++)
                {
                        StringBuffer fileBuff=new StringBuffer();
                        fileBuff.append("CirFiles/"); 
                        fileBuff.append(directList[i]);
                        filename=new String (fileBuff.toString());
                  try  {
    			fin =  new FileInputStream(filename);
 
  			// now turn the FileInputStream into a DataInputStream
    			try {
      				myInput = new DataInputStream(fin);
      				try {
           				thisLine = myInput.readLine();
 			               // directBuff.append(thisline);	
 			                labels[i+1]=new String(thisLine);	
                                }
      				catch (Exception e) {
      				System.out.println("Error: " + e);
      				}
    			} // end try
    			catch (Exception e) {
      				System.out.println("Error: " + e);
   			}
		  } // end try
   		  catch (Exception e) {
    			System.out.println("Failed to open file " + filename);
   	 		System.out.println("Error: " + e);
  		  }
                }
        	//return directList;
        	return labels;
	  } 
       	  catch (Exception e) {
            	System.out.println("No files found in the directory.");
        	return labels;
       	  }
        }
        catch (Exception e) {
            	System.out.println("Directory CirFiles not found");
       	    return labels;
        }
    }
 
    /**
     * Select the specified tool. The parameter will be one of the tool
     * names returned by getLabels(). The toolset should construct an
     * appropriate Tool object and tell the workbench to use it.
     */
    public void selectTool(String toolName, Workbench wb) {
        String ToolName=null;
        int Size=directList.length;
        int i=0;
        if (toolName.equals(labels[0]))
            {
	     PaletteTool tool = new PaletteTool(wb, Palette.class, toolName);
	     wb.setCurrentTool(tool);
            }
       else
       { 
       	 for (i=0; i<Size;i++)
         {
             if (toolName.equals(labels[i+1]))
               ToolName=new String (directList[i]); 
         } 
         StringBuffer filenamebuff= new StringBuffer();
        filenamebuff.append("CirFiles/");
        filenamebuff.append(ToolName);
        String fileName = filenamebuff.toString();
	PaletteTool tool = new PaletteTool(wb, Palette.class, fileName);
	wb.setCurrentTool(tool);
       
         }
    }

}
