package sieve.phys.circuit;

import java.beans.*;
import java.awt.*;

/**
 * This class provides info about which properties of the Resistor class
 * should be made editable.
 */
public class ResistorBeanInfo extends SimpleBeanInfo {

    public BeanDescriptor getBeanDescriptor() {
        BeanDescriptor bd = new BeanDescriptor(Resistor.class);
        bd.setDisplayName("Resistor");
        return bd;
    }

    public PropertyDescriptor[] getPropertyDescriptors() {
        PropertyDescriptor[] myProps = new PropertyDescriptor[5];
        try {
            myProps[0] = new PropertyDescriptor("Resistance", Resistor.class);
            myProps[1] = new PropertyDescriptor("Node1", Resistor.class);
            myProps[2] = new PropertyDescriptor("Node2", Resistor.class);
            myProps[3] = new PropertyDescriptor("Direction", Resistor.class); 
            myProps[4] = new PropertyDescriptor("Orientation", Resistor.class); 
        }
        catch(Exception e) {
            e.printStackTrace();
        }
        return myProps;
    }
}

