package sieve.phys.circuit;

import java.awt.*;
import java.io.IOException;
import java.util.*;

public class Search{
  
   Vector    StoredPathVector;
   Vector    SortedPathVector;
   Vector    EdgesInLoop;
   AGraph     AdjGraph;


   public Search(){
      StoredPathVector = new Vector();
      SortedPathVector = new Vector();
      EdgesInLoop = new Vector();

   }

   public boolean edgeIsInLoop(int EdgeID){
      boolean found = false;
      Integer EIDVect;
      for(int i = 0; (i < EdgesInLoop.size()) && !(found); i++){
         EIDVect = (Integer)EdgesInLoop.elementAt(i);
         if (EIDVect.intValue() == EdgeID)
            found = true;
      }
      return found;
   }

   public void addEdge(int EdgeID){
      Integer EIDVect = new Integer(EdgeID);
      EdgesInLoop.addElement(EIDVect);
   }

   public void removeEdge(int EdgeID){
      boolean found = false;
      Integer EIDVect;
      for(int i = 0; (i < EdgesInLoop.size()) && !(found); i++){
         EIDVect = (Integer)EdgesInLoop.elementAt(i);
         if (EIDVect.intValue() == EdgeID){
            EdgesInLoop.removeElementAt(i);
            found = true;
         }
      }
}
         
   public Vector findLoops(AGraph inGraph){
      Edge TempEdge;     
      EdgesInLoop = new Vector();

      AdjGraph = inGraph;

      StoredPathVector = new Vector();
      Vector DummyPath;
      TempEdge = new Edge();
      Integer Local;
      Local = new Integer(1);
      DummyPath = new Vector();
      TempEdge = AdjGraph.First(1);

      DummyPath.addElement(Local);
      LoopSearch(TempEdge, DummyPath);
      AdjGraph.AssignCurrentValues();
      SortedPathVector = new Vector();
      return StoredPathVector;
   }

   
   private void LoopSearch(Edge EdgeAlpha, Vector PathName){
       /* Create a local instance of this Vector */
      Vector Path;
      Vector EdgePath;
      Path = new Vector();
      Edge TempEdge = new Edge();
      EdgePath = new Vector();
      Integer TempInt;
      TempInt = new Integer(-1);

      if (!PathName.isEmpty())
        for(int i = 0; i < PathName.size(); i++){
           Path.addElement(PathName.elementAt(i));
        }

      Integer VectInt = new Integer(EdgeAlpha.positiony);
      if (Path.size() >= 2){
           TempInt = (Integer)Path.elementAt((Path.size()-2));
      }

      //check if node just visited is last one in path
      if(VectInt.intValue() != TempInt.intValue()){
         if(Path.contains(VectInt)){
            Path.addElement(VectInt);
            GetEdgePath(Path, EdgePath);
            if(DistinctLoop(EdgePath)){
//               System.out.println("This is a loop: ");
               StorePath(Path);
//               PrintPath(Path);
            }
         }
         else{
           Path.addElement(VectInt);
           LoopSearch(AdjGraph.First(EdgeAlpha.positiony), Path);
         }
      }
      TempEdge = AdjGraph.Next(EdgeAlpha.positionx, EdgeAlpha.positiony);
      if (TempEdge.On == 1)
         LoopSearch(TempEdge, PathName);
   }

   private void GetEdgePath(Vector AlphaPath, Vector EdgePath){

      Integer localInt1;
      Integer localInt2;
      Integer LastInt;
      Integer EdgeInt;

      LastInt = (Integer)AlphaPath.lastElement();

      int j = AlphaPath.indexOf(LastInt, 0);

      for(int i = j; i < AlphaPath.size() -1; i++){
         localInt1 = (Integer)AlphaPath.elementAt(i);
         localInt2 = (Integer)AlphaPath.elementAt(i + 1);
         EdgeInt = new Integer(AdjGraph.EID(localInt1.intValue(), localInt2.intValue()));
         EdgePath.addElement(EdgeInt);

      }

  }

  private void PrintPath(Vector AlphaPath){
      Integer localInt;
      Integer LastInt;
      LastInt = (Integer)AlphaPath.lastElement();

      int j = AlphaPath.indexOf(LastInt, 0);

      for(int i = j; i < AlphaPath.size(); i++){
         localInt = (Integer)AlphaPath.elementAt(i);
         System.out.println(" ");
         System.out.print(" " + localInt.intValue());
         System.out.print(" ");
      }

     System.out.println("");
  }


   private void StorePath(Vector AlphaPath){

      Integer LastElement = (Integer)AlphaPath.lastElement();
      Integer FirstElement = (Integer)AlphaPath.firstElement();
      Integer TempInt;
      Integer TempInt2;
      Edge TempEdge;
      Vector TempVector = new Vector();

      int i = 0;

      while (FirstElement.intValue() != LastElement.intValue()){
         i++;
         FirstElement = (Integer)AlphaPath.elementAt(i);
      }

      for(int k=i; k < (AlphaPath.size()-1); k++){
         TempInt = (Integer)AlphaPath.elementAt(k);
         TempInt2 = (Integer)AlphaPath.elementAt(k+1);
         TempEdge = AdjGraph.getEdge(TempInt2.intValue(), TempInt.intValue());
         if ((TempEdge.EID != -1) && !(edgeIsInLoop(TempEdge.EID))){
            addEdge(TempEdge.EID);
//            System.out.println("Added edge between: " + TempInt.intValue() +
//               " " + TempInt2.intValue());
         }
      }

      for(int k=i; k < AlphaPath.size(); k++){
         TempInt = (Integer)AlphaPath.elementAt(k);
         TempVector.addElement(TempInt);
      }

      StoredPathVector.addElement(TempVector);
   }


   private boolean DistinctLoop(Vector AlphaPath){

   Integer TempInt;
   Integer localInt;
   Integer LastInt = (Integer)AlphaPath.lastElement();
   int j = AlphaPath.indexOf(LastInt, 0);
   Vector TempVector = new Vector();
   TempVector.addElement(AlphaPath.firstElement());
   int i = 1;
   int k = 0;

   /*This code sorts the vector into increasing order */
   while(i <= (AlphaPath.size()-1)){
      localInt = (Integer)AlphaPath.elementAt(i);
      TempInt = (Integer)TempVector.elementAt(k);
      while ((localInt.intValue() > TempInt.intValue()) && (k <= (TempVector.size()-1))){
         k++;
         if (k <= (TempVector.size()-1))
            TempInt = (Integer)TempVector.elementAt(k);
      }
      if(k > (TempVector.size()-1)){
         TempVector.addElement(localInt);
      }
      else{
         TempVector.insertElementAt(localInt, k);
      }
      i++;
      k = 0;
   }

   boolean notSame = false;
   for (int l = 0; l <= (SortedPathVector.size()-1); l++){
      Vector SearchVector = (Vector)SortedPathVector.elementAt(l);
      if(SearchVector.size() == TempVector.size()){
         for(int m = 0; m <= (TempVector.size() -1) && (notSame == false); m++){
            Integer CompareTemp;
            Integer SearchInt;
            SearchInt = (Integer)SearchVector.elementAt(m);
            CompareTemp = (Integer)TempVector.elementAt(m);
            if (CompareTemp.intValue() != SearchInt.intValue()){
               notSame = true;
            }
         }
         if (notSame == false){
            return false;
         }
         else{
            notSame = false;
         }
      }
   }

      SortedPathVector.addElement(TempVector);
      return true;
   }

  

}
 
