package sieve.phys.circuit;
import java.awt.*;
import java.lang.Math;
 
public class Voltmeter extends Resistor {
        private double Ohms; 
        private double Amps;
        private Math power;
 
Voltmeter(int SetID){
        ComponentID = SetID;
        Ohms = 1000;
//        Ohms = power.pow(10, 6);
        setResistance((int)Math.pow(10, 14));
}
 
Voltmeter(){
        ComponentID = -1;
        Ohms = 1000;
//        Ohms = power.pow(10, 6);
        setResistance((int)Math.pow(10, 14));
}
public void setAmps(double Amp){
    	Amps = Amp; // this will round up for us.
        double Volts=Amps * getResistance();
        System.out.println("Volts:"+ Volts); 
        this.repaint();
}
 public void layout() {
       if (Orientation)
        {
        Dimension pref = t1.getPreferredSize();
        t1.setBounds(2, 2, pref.width, pref.height);
        pref = t2.getPreferredSize();
        t2.setBounds(98 - pref.width, 2, pref.width,
            pref.height);
        setSize(100,40);
        }
      else
        {
         Dimension pref = t1.getPreferredSize();
        t1.setBounds((50 - pref.width), 2, pref.width, pref.height);
        pref = t2.getPreferredSize();
        t2.setBounds((50 - pref.width) , 68 - pref.height, pref.width, pref.height);
        setSize(50,70);
        }
 
    }
 
    public Dimension getPreferredSize() {
       if (Orientation)
        return new Dimension(100,40);
        else
        return new Dimension(50,70);
 
 
    }
 public Dimension getMinimumSize() {
        if (Orientation)
        return new Dimension(100,40);
        else
        return new Dimension(50,70);
 
 
    }

public void paint(Graphics g) {
        Rectangle t1Bounds = t1.getBounds();
        Rectangle t2Bounds = t2.getBounds();
        Dimension maxdim=getPreferredSize();
        if (selected || red)
            g.setColor(Color.red);
        else
            g.setColor(Color.black);
       // int y = t1Bounds.y + t1Bounds.height/2+10;
        int y =maxdim.height/2;
 
        int x = t1Bounds.x+t1Bounds.width/2;
        int w =t2Bounds.x-x+t2Bounds.width/2;
        int h=20;
 
        int pt1, pt2, pt3, pt4, pt5, pt6, pt7, pt8, pt9,Sheight, Swidth;
        if (Orientation)
         {  
        pt1=x+w/6;
        pt4 =x+w*5/6;
        pt2 =pt1+(pt4-pt1)/3;
        pt3 =pt1+(pt4-pt1)*2/3;
	
        g.drawLine(x, y, pt1, y);
        g.drawLine(x, y, x, t1Bounds.y+t1Bounds.height);
        g.drawOval(pt1, t1Bounds.height ,pt4-pt1,maxdim.height-t1Bounds.height-2 );
 
        g.drawLine(pt4, y, x+w, y);
        g.drawLine(x+w, y, x+w, t2Bounds.y+t1Bounds.height);
	FontMetrics fm = g.getFontMetrics();
        double Volts=Amps * getResistance() +0.0005;

         if(Volts<1.0 && Volts >-1.0)
        {   // display MilliVolts 
             StringBuffer VoltBuffer= new StringBuffer();
            String VoltString=  Integer.toString((new Double(Volts*1000)).intValue());
            VoltBuffer.append(VoltString);
            VoltBuffer.append("mV");
            String DisplayStr=VoltBuffer.toString();
            Sheight=fm.getHeight();
            Swidth=fm.stringWidth(DisplayStr);
            g.drawString(DisplayStr, x+(w-Swidth)/2,t1Bounds.height+(maxdim.height-t1Bounds.height-2)/2);
        }
        else
        {   // display Volts 
             StringBuffer VoltBuffer= new StringBuffer();
            String VoltString=  Integer.toString((new Double(Volts)).intValue());
            VoltBuffer.append(VoltString);
            VoltBuffer.append("V");
            String DisplayStr=VoltBuffer.toString();
            Sheight=fm.getHeight();
            Swidth=fm.stringWidth(DisplayStr);
            g.drawString(DisplayStr, x+(w-Swidth)/2,t1Bounds.height+(maxdim.height-t1Bounds.height-2)/2);
            //g.drawString(DisplayStr, x+(w-Swidth)/2,y);
        }

        g.fillRect(t1Bounds.x, t1Bounds.y, t1Bounds.width, t1Bounds.height);
        g.fillRect(t2Bounds.x, t2Bounds.y, t2Bounds.width, t2Bounds.height);
       }
       else if (!Orientation) 
       {
     //  x=t1Bounds.x+t1Bounds.width/2-10;
          x=maxdim.width/2;
          w=maxdim.width;
          y=t1Bounds.y+t1Bounds.height/2;
          h=t2Bounds.y-t1Bounds.y+t2Bounds.height/2;
          pt1=y+h*3/12;
          pt4 =y+h*9/12;
          pt2 =pt1+(pt4-pt1)/3;
          pt3 =pt1+(pt4-pt1)*2/3;
          g.drawLine(x, y, x, pt1); 
          g.drawLine(x, y, t1Bounds.x, y); 
          g.drawOval(x-(maxdim.width-2)/2,pt1 ,maxdim.width-2,pt4-pt1 );
          g.drawLine(x,pt4,x,y+h);
          g.drawLine(x,y+h,t2Bounds.x,y+h);
         FontMetrics fm = g.getFontMetrics();
        double Volts=Amps * getResistance() +0.0005;
         if(Volts<1.0 && Volts >-1.0)
        {   // display MilliVolts 
             StringBuffer VoltBuffer= new StringBuffer();
            String VoltString=  Integer.toString((new Double(Volts*1000)).intValue());
            VoltBuffer.append(VoltString);
            VoltBuffer.append("mV");
            String DisplayStr=VoltBuffer.toString();
            Sheight=fm.getHeight();
            Swidth=fm.stringWidth(DisplayStr);
            g.drawString(DisplayStr, (w-Swidth)/2,maxdim.height/2);
        }
        else
        {   // display Volts 
             StringBuffer VoltBuffer= new StringBuffer();
            String VoltString=  Integer.toString((new Double(Volts)).intValue());
            VoltBuffer.append(VoltString);
            VoltBuffer.append("V");
            String DisplayStr=VoltBuffer.toString();
            Sheight=fm.getHeight();
            Swidth=fm.stringWidth(DisplayStr);
            g.drawString(DisplayStr, (w-Swidth)/2,maxdim.height/2);
        }

         g.fillRect(t1Bounds.x, t1Bounds.y, t1Bounds.width, t1Bounds.height);
        g.fillRect(t2Bounds.x, t2Bounds.y, t2Bounds.width, t2Bounds.height);
       }
// super.paint(g);
    }
 
 
}

