package sieve.phys.lwblockandplane;


import java.beans.*;
import java.lang.reflect.*;

public class BlockAndPlaneBeanInfo extends SimpleBeanInfo {

    public BeanDescriptor getBeanDescriptor() {
	BeanDescriptor bd = new BeanDescriptor(BlockAndPlane.class);
	bd.setDisplayName("Collaborative Block and Plane");
	return bd;
    }

  
   public PropertyDescriptor[] getPropertyDescriptors() {
	PropertyDescriptor[] myProps = new PropertyDescriptor[17];
	try {
	  int i = 0;
	    myProps[i++] = new PropertyDescriptor("TimeStep", BlockAndPlane.class);
	    myProps[i++] = new PropertyDescriptor("Plane1Height", BlockAndPlane.class);
	    myProps[i++] = new PropertyDescriptor("Plane1Length", BlockAndPlane.class);
	    myProps[i++] = new PropertyDescriptor("Plane1Angle", BlockAndPlane.class);
	    myProps[i++] = new PropertyDescriptor("Plane1MuS", BlockAndPlane.class);
	    myProps[i++] = new PropertyDescriptor("Plane1MuK", BlockAndPlane.class);
	    myProps[i++] = new PropertyDescriptor("Plane2Height", BlockAndPlane.class);
	    myProps[i++] = new PropertyDescriptor("Plane2Length", BlockAndPlane.class);
	    myProps[i++] = new PropertyDescriptor("Plane2Angle", BlockAndPlane.class);
	    myProps[i++] = new PropertyDescriptor("Plane2MuS", BlockAndPlane.class);
	    myProps[i++] = new PropertyDescriptor("Plane2MuK", BlockAndPlane.class);
	    myProps[i++] = new PropertyDescriptor("FloorLength", BlockAndPlane.class);
	    myProps[i++] = new PropertyDescriptor("FloorMuS", BlockAndPlane.class);
	    myProps[i++] = new PropertyDescriptor("FloorMuK", BlockAndPlane.class);
	    myProps[i++] = new PropertyDescriptor("MovingBodyHeight", BlockAndPlane.class);
	    myProps[i++] = new PropertyDescriptor("MovingBodyLength", BlockAndPlane.class);
	    myProps[i++] = new PropertyDescriptor("Gravity", BlockAndPlane.class);
	}
	catch(Exception e) {
	    e.printStackTrace();
	}
	return myProps;
    }


  public EventSetDescriptor[] getEventSetDescriptors() {
    SecurityManager security = System.getSecurityManager();
    if (security == null) {
      return null;
    } else {
      try {
        security.checkMemberAccess(BlockAndPlane.class, 
				   Member.DECLARED);
	return new EventSetDescriptor[0];
      } catch (SecurityException ex) {
	return null;
      }
    }
  } 
  
  public MethodDescriptor[] getMethodDescriptors() {
    SecurityManager security = System.getSecurityManager();
    if (security == null) {
      return null;
    } else {
      try {
        security.checkMemberAccess(BlockAndPlane.class, 
				   Member.DECLARED);
	return new MethodDescriptor[0];
      } catch (SecurityException ex) {
	return null;
      }
    }
  }

    
}


