package sieve.phys.lwblockandplane;
import java.awt.*;
import java.lang.Float;

public class FloorDialog extends Dialog {

Button Cancel = new Button("Cancel");
Button Ok	    = new Button("Ok");
Plane  plane  = null;
Label LengthLabel      = null;
TextField LengthField  = null;
Label MuSLabel         = null;
TextField MuSField     = null;
Label MuKLabel         = null;
TextField MuKField     = null;
BlockAndPlane bnp = null;

public FloorDialog(Plane p, Frame parentFrame, BlockAndPlane bnp) {
   super(parentFrame, "Change Floor Parameters", false);
   this.bnp = bnp;
   plane = p;   
   Panel p1 = new Panel();
   p1.setLayout(new GridLayout(0,2));
   // Length
   LengthLabel = new Label("Length: (m) ",Label.LEFT);
   Float f = new Float(plane.getLength());
   LengthField = new TextField(f.toString(),10);
   p1.add(LengthLabel);
   p1.add(LengthField);
   // MuS
   MuSLabel = new Label("MuS: ",Label.LEFT);
   f = new Float(plane.getMuS());
   MuSField = new TextField(f.toString(),10);
   p1.add(MuSLabel);
   p1.add(MuSField);
   // MuK
   MuKLabel = new Label("MuK: ",Label.LEFT);
   f = new Float(plane.getMuK());
   MuKField = new TextField(f.toString(),10);
   p1.add(MuKLabel);
   p1.add(MuKField);

   p1.add(Ok);
   p1.add(Cancel);

   setLayout(new GridLayout(0,1));
   add(p1);   
   
   //Initialize this dialog to its preferred size.
   pack();
}
public boolean action(Event event, Object arg) {
Float f1 = null,f2 = null;
Double d = null;
   if (event.target == Cancel){
      bnp.refresh();
   	 hide();
      return true;
    }
   if (event.target == Ok) {
      plane.setLength((Float.valueOf(LengthField.getText())).floatValue());
      plane.setMuS((Float.valueOf(MuSField.getText())).floatValue());
      plane.setMuK((Float.valueOf(MuKField.getText())).floatValue());
      hide();
      bnp.refresh();
      return true;
   } 
   return false; 
}
} 
