package sieve.phys.lwblockandplane;

import sieve.sluice.*;
import sieve.sluice.event.*;
import sieve.sluice.local.*;
import java.util.*;
import java.awt.Color;

public class SimTable extends sieve.sluice.local.TableImpl {
    int runNumber = -1;
    Hashtable attrs = new Hashtable();

    public SimTable(int runNumber) {
	this.runNumber = runNumber;
	makeFieldDescriptor("Time", Color.black);
	makeFieldDescriptor("Distance", Color.blue);
	makeFieldDescriptor("Velocity", Color.red);
	makeFieldDescriptor("Acceleration", Color.green);
    }

    private void makeFieldDescriptor(String name, Color color) {
	FieldDescriptor fd = new FieldDescriptor(name);
	fd.setType("java.lang.Long");
	fd.setLevel(FieldDescriptor.LEVEL_INTERVAL); // ??
	fd.setColor(color);

	// Need desc (units) also...

	try {
	    addField(fd);
	}
	catch(InterchangeException e) {
	    e.printStackTrace();
	}
    }

    public TableDescriptor getTableDescriptor() throws NoSourceException {
	TableDescriptor td = super.getTableDescriptor();
	td.setName("Run " + runNumber+ " of Block and Plane");
	for (Enumeration e = attrs.keys(); e.hasMoreElements();) {
	    String name = (String)e.nextElement();
	    td.setAttribute(name, attrs.get(name));
	}
	return td;
    }

    public void addObservation(float time, double distance, double velocity,
	double acceleration) throws InterchangeException {


	// Probably want to use java.lang.Double's?
	Object[][] row = {
	 	{ new Long((long)(time * 1000))         },
		{ new Long((long)(distance * 1000))     },
	    	{ new Long((long)(velocity * 1000))     },
	    	{ new Long((long)(acceleration * 1000)) }
	    };
	append(row);
    }

    public void setAttribute(String name, Object value) {
	attrs.put(name, value);
    }

}




