package sieve.quarry;

import java.awt.*;
import java.io.Serializable;
import java.beans.*;
import java.util.*;
import sieve.sluice.*;
import sieve.crew.*;

public class CustomizerPanel extends Panel implements 
    PropertyChangeListener, RemotePropertyChangeListener {

    protected Object	  bean    = null;
    protected Font        f       = null;
    protected FontMetrics fm      = null;
    protected int         height  = 0;
    protected int         width   = 0;
    protected int         baseline= 0;

    protected String 	  label   = null;
    protected Label	  header  = null;

    protected Component	  customizer	= null;

    public CustomizerPanel(String label_UNUSED, Object bean) {
	this.bean = bean;
	this.label = findLabel(bean);
        setName(label);

	addCustomizer(bean);
/*
   	else {
	    f = new Font("Helvetica", Font.PLAIN, 10);
            setFont(f);
            fm = getFontMetrics(f);
            baseline = fm.getMaxAscent() + 2;
            height = baseline + fm.getMaxDescent() + 2;
            width = fm.stringWidth(label) + 6;
            resize(width,height);
	}
*/
    }

    private String findLabel(Object bean) {
	String name = bean.getClass().getName();
	try {
	    BeanInfo bi = Introspector.getBeanInfo(bean.getClass());
            BeanDescriptor bd = bi.getBeanDescriptor();
	    name = bd.getDisplayName();
        }
	catch (Exception e) {
	    e.printStackTrace();
	}
	return name;
    }

    public void setName(String name) {
	super.setName(name);
	label = name;
	if (header != null)
	    header.setText(label);
    }

    private void addCustomizer(Object bean) {
	setLayout(new BorderLayout());
	try {
	    BeanInfo bi = Introspector.getBeanInfo(this.bean.getClass());
            BeanDescriptor bd = bi.getBeanDescriptor();
            Class customizerClass = bd.getCustomizerClass();
	    header = new Label(label);
	    header.setAlignment(Label.CENTER);
            add("North", header);

	    if (customizerClass == null) {
		customizer = new PropertyPanel(this.bean);
	    }
	    else {
		customizer = (Component)customizerClass.newInstance();
		((Customizer)customizer).setObject(this.bean);
	        ((Customizer)customizer).addPropertyChangeListener(this);
	    }
	    add("Center", customizer);
	    invalidate();
	    Dimension size = customizer.getPreferredSize();
	    resize(size.width, size.height);
	    if (getParent() != null)
	        getParent().layout();
	}
	catch (Exception e) {
	    e.printStackTrace();
	}
    }

    private void removeCustomizer() {
	if (customizer != null) {
	    remove(customizer);
	    remove(header);
	    customizer = null;
	}
    }

    public Dimension getPreferredSize() {
    	if (customizer != null)
	    return super.getPreferredSize();
	else
	    return new Dimension(width, height);
    }

    public synchronized void remotePropertyChange(PropertyChangeEvent evt) {
      if (customizer != null) {
        if (customizer instanceof PropertyChangeListener) {
          ((PropertyChangeListener)customizer).propertyChange(evt);
	}
        else {
          removeCustomizer();
	  addCustomizer(this.bean);
        }
      } 
    }

    public void propertyChange(PropertyChangeEvent evt) {
      BeanBox box = BeanBox.findBeanBox(this);
      if ((box != null) &&  (box instanceof QuarryBox)) {
         ((QuarryBox)box).notifyParticipants(NuggetMessage.MODIFY,
           new NuggetChangeInfo(bean, evt.getPropertyName(), 
           evt.getNewValue()));
      }
    }

}

