
// Support for PropertyEditor with custom editors.

package sieve.quarry;

import java.awt.*;
import java.beans.*;

public class PropertyDialog extends Dialog {

    public PropertyDialog(Frame frame, PropertyEditor pe, int x, int y) {
	super(frame, pe.getClass().getName(), true);
	setLayout(null);
	Component body = pe.getCustomEditor();
	add(body);

	int top = 28;
	int width = body.preferredSize().width + 8;
	int height = body.preferredSize().height;

        body.setBounds(4, top, width, height+2);

	doneButton = new Button("Done");
	add(doneButton);
	doneButton.setBounds((width-50)/2, top+height+4, 50, 30);

	setBounds(x, y, width+10, top + height + 44);

	show();
    }

    public boolean handleEvent(Event evt) {

	if (evt.id == Event.ACTION_EVENT && evt.target == doneButton) {
	   // Button down.
	    dispose();
	    return (true);
	} else if (evt.id == Event.WINDOW_DESTROY) {
	    dispose();
	    return (true);
	}
	return (false);
    }

    Button doneButton;
}

