package sieve.sluice;

import sieve.workbench.*;
import java.awt.*;

public class TableViewTableViewLink extends SimpleLink {
    private TableView sourceView = null;
    private TableView destView = null;

    public void link(WorkbenchComponent source, WorkbenchComponent dest) 
	throws LinkException {

	// Make sure our source and dest are actually TableViews
        if ((dest.getModel() instanceof TableView) &&
            (source.getModel() instanceof TableView)) {

	    // Connect the source and destination
	    sourceView = (TableView)source.getModel();
	    destView = (TableView)dest.getModel();
            try {
                destView.addSourceView(sourceView); 
                sourceView.addTableViewListener(destView);
                setColor(Color.black);
            }
            catch (TooManySourcesException e) {
                throw new LinkException("Too many sources");
            }
        }
	else 
            throw new LinkException("Incompatible source and destination");
    }

    public void unlink(WorkbenchComponent source, WorkbenchComponent dest) {
	// Make sure we're actually connected
	if ((destView != null) && (sourceView != null)) {
	    // Disconnect the source and destination
            try {
                destView.removeSourceView(sourceView);
		sourceView.removeTableViewListener(destView);
            }
            catch (Exception e) {} // Fail quietly on disconnect
        }
    }

}

