package sieve.sluice.local;
 
import sieve.sluice.*;
import sieve.sluice.views.*;
import sieve.nuggets.*;
import java.util.*;
import java.awt.*;


public class ChartTest extends sieve.nuggets.BarChart {
    Table table = null;

    public ChartTest() throws InterchangeException {
	super();
	setFont(new Font("Dialog", Font.PLAIN, 10));

	// Instantiate a new local table
	table = new sieve.sluice.local.TableImpl();

	// Add a "Grades" field
	FieldDescriptor fd = new FieldDescriptor("Grades");
        fd.setType("java.lang.String");
	table.addField(fd);

	// Add a "Frequency" field
	fd = new FieldDescriptor("Frequency");
        fd.setType("java.lang.Integer");
        fd.setLevel(FieldDescriptor.LEVEL_INTERVAL);
	table.addField(fd);

	// Add some records to the table
	Object[][] values = {
	    {"A", "B", "C", "D", "F"},
	    {new Integer(3), new Integer(5), new Integer(8), new Integer(3),
	    new Integer(1)}};

	table.append(values);

	// Associate the color blue with the "Frequency" field
	sieve.sluice.views.ColorChangeView cv =
	    new sieve.sluice.views.ColorChangeView();

	cv.addSourceView(table);
	cv.setField("Frequency");
	cv.setColor(Color.blue);

        // Add the (filtered) view as our source
	addSourceView(cv);
    }

}




