package sieve.sluice.views;

import sieve.sluice.*;
import java.util.*;

/**
 * This view provides convenience methods for accessing cells, rows, and
 * fields. It does not filter or modify its source in any way.
 */
public class ApplicationSupportView extends DefaultTableView implements 
    TableView {

    public ApplicationSupportView(TableView source) {
	super(source);
    }

    /**
     * Get a single cell.
     */
    public Object get(String field, int record) throws InterchangeException {
	String[] flds = {field};
	Object[][] data = get(flds, record, 1);
	return data[0][0];
    }
	
    /**
     * Get a single field as an array.
     */
    public Object[] getField(String field, int startingAt, 
	int numberOfRecords) throws InterchangeException {
	String[] flds = {field};
	Object[][] data = get(flds, startingAt, numberOfRecords);
	return data[0];
    }

    /**
     * Get a single field as an array.
     */
    public Object[] getField(String field, int startingAt) 
	throws InterchangeException {
	return getField(field, startingAt, getRecordCount() - startingAt);
   }

    /**
     * Get a single record as an array.
     */
   public Object[] getRecord(int record) throws InterchangeException {
	Object[][] data = get(getFieldNames(), record, 1);

	/* Have to transpose the data in this case... */
	Object[] recordArray = new Object[data.length];
	for (int i = 0; i < data.length; i++) 
		recordArray[i] = data[i][0];
	return recordArray;
    }
}


