package sieve.sluice.views;

import sieve.sluice.*;
import sieve.sluice.event.*;
import java.util.*;
import java.awt.*;
import java.beans.*;

/**
 * Changes the color of a single field, passing all other fields
 * unaltered.
 */
public class ColorChangeView extends DefaultTableView implements 
    TableView, TableViewListener {

    String    	 field = null;
    Color	 color = Color.black;

    public ColorChangeView() {
    	super(null);
    }

    public void setField(String field) throws InterchangeException {
    	if (source == null)
      	    throw new NoSourceException();
    	if (!field.equals(this.field)) {
            this.color = source.getFieldDescriptor(field).getColor();
	    String oldField = this.field;
      	    this.field = field;
      	    eventHandler.fireTableViewEvent(
		new FieldDescriptorChangeEvent(this, field));
	    changes.firePropertyChange("field", oldField, field);
        }
    }

    public String getField() {
    	return field;
    }

    public void setColor(Color color) throws InterchangeException {
    	if (source == null)
       	    throw new NoSourceException();
        if (color != this.color) {
	    Color oldColor = this.color;
      	    this.color = color;
            eventHandler.fireTableViewEvent(
		new FieldDescriptorChangeEvent(this, field));
	    changes.firePropertyChange("color", oldColor, color);
      	}
    }

    public Color getColor() {
    	return color;
    }

    public FieldDescriptor getFieldDescriptor(String field) throws 
    	InterchangeException {

      	if (source == null)
      	    throw new NoSourceException();

    	FieldDescriptor fd = source.getFieldDescriptor(field).copy();
    	if (field.equals(this.field)) {
      	    fd.setColor(color);
        }
        return fd;
    }

}



