package sieve.sluice.views;

import java.beans.*;
import java.awt.*;
import java.awt.event.*;
//import com.sun.java.swing.*;

import sieve.sluice.*;

public class FieldNameSelectionViewCustomizer extends Panel implements 
    Customizer, TableViewListener, PropertyChangeListener, ItemListener {
    public static final String NOT_CONNECTED_MSG = "(Not Connected)";

    protected FieldNameSelectionView	target;
    protected List					fieldList;
    protected String[] 				fields;

    public FieldNameSelectionViewCustomizer() {
		setLayout(new BorderLayout());
    }

    public void setObject(Object obj) {
		target = (FieldNameSelectionView) obj;
		target.addTableViewListener(this);
		fieldList = new List(5, true);
		fieldList.addItemListener(this);
		updateList();
		add(fieldList);
    }

    protected void updateList() {
	/*
	 * Hmmm... We'd really like to get all of the fields here,
	 * but after a field is selected, all other fields are
	 * hidden by the FieldNameSelectionView. 
	 * This may provide sufficient justification for adding a 
	 * source() method...
	 */
      	String[] newFields = null;
		try { newFields = target.getAvailableFieldNames(); }
        catch (Exception e) { } // WHAT TO DO HERE? 
		if (newFields == null) {
			fieldList.removeAll();
			fieldList.addItem(NOT_CONNECTED_MSG);
			fieldList.setEnabled(false);
		}
		else {
			String desc;
			if (newFields.length == 0)
				fieldList.setEnabled(false);
			else {
				fieldList.setEnabled(true);
				for (int i=0; i < newFields.length; i++) {
					desc = null;
					try { desc = target.source.getFieldDescriptor(newFields[i]).getDescription(); }
					catch (Exception e) {}

				    if ((desc == null) || desc.equals(newFields[i]))
			           desc = newFields[i];
				    else
					   desc = desc + " (" + newFields[i] + ")";
				    if (i >= fieldList.getItemCount())
			            fieldList.addItem(desc);
					else if (!desc.equals(fieldList.getItem(i)))
						fieldList.replaceItem(desc, i); 
				}
			}//else (newFields.length != 0)

		fields = newFields;
	    String[] currentFields = target.getFields();
	    if (currentFields != null) {
		for (int i = 0; i < currentFields.length; i++) {
		    for (int j = 0; j < fields.length; j++) {
			if (currentFields[i].equals(fields[j])) {
			    if (!fieldList.isIndexSelected(j))
			        fieldList.select(j);
			    j = fields.length; // Break out
			}
		    }
		}
	    }
	}
	repaint();
    }

    public Dimension getPreferredSize() {
	return new Dimension(2 * fieldList.getPreferredSize().width, 
	    fieldList.getPreferredSize().height);
    }

    public void itemStateChanged(ItemEvent evt) {
        /*
         * Since we may have field descriptions (rather than field names)
         * in the List widget, translate indices here.
         */
        int[] selection = fieldList.getSelectedIndexes();
        String[] selectedFields = new String[selection.length];

        for (int i = 0; i < selection.length; i++) 
                selectedFields[i] = fields[selection[i]];
	support.firePropertyChange("fields", target.getFields(), selectedFields);
	target.setFields(selectedFields);
    }

    //----------------------------------------------------------------------

    public void addPropertyChangeListener(PropertyChangeListener l) {
	support.addPropertyChangeListener(l);
    }

    public void removePropertyChangeListener(PropertyChangeListener l) {
	support.removePropertyChangeListener(l);
    }

    protected PropertyChangeSupport support = new PropertyChangeSupport(this);

    //----------------------------------------------------------------------

   public void tableViewChanged(TableViewEvent event) {
	updateList();
   }

   public void propertyChange(PropertyChangeEvent evt) {
        if (evt.getPropertyName().equals("fields")) {
	    String[] selectedFields = (String[])evt.getNewValue();
	    if (selectedFields != null) {
		for (int i = 0; i < fields.length; i++) {
	            fieldList.deselect(i);
		    for (int j = 0; j < selectedFields.length; j++) 
			if (fields[i].equals(selectedFields[j]))
			    fieldList.select(i);
		}
	    }
        }
    }


}

