package sieve.sluice.views.predicates;

import java.beans.*;
import java.lang.reflect.*;
import java.util.*;

/**
 * Command-pattern-ish class for abstracting predicates for comparing
 * (or testing) objects.
 * Core reflection is used to pick out methods which take one or two
 * arguments and have boolean return type.
 * The names of each method should be a human-readable description
 * of the predicate.
 */
public class ObjectPredicates {
    
    public ObjectPredicates() {}

    /**
     * Returns true if the references are equal or if the equals() method
     * returns true.
     */
    public boolean isEqualTo(Object first, Object second) {
	if ((first != null) && (second != null))
	    return (first == second) || first.equals(second);
	else 
	    return false;
    }

    /**
     * Returns true if the object is null.
     */
    public boolean isMissing(Object obj) {
	return (obj == null);
    }
}


