package sieve.whiteboard;

import java.awt.*;
import java.awt.event.*;
import sieve.workbench.*;

/**
 * Tool for constructing a Box object.
 */
public class BoxTool implements Tool {
    Workbench wb = null;
    Box box = null;

    public BoxTool(Workbench wb) {
	this.wb = wb;
    }

    public BoxTool() { }

    public void init(Workbench wb, Class cl) {
	this.wb = wb;
    }

    private void handleMouseEvent(MouseEvent e) {
	if (box != null) {
	    box.end = e.getPoint();
	    box.setBounds(box.getBounds());
	    box.repaint();
	}
    }

    public void mousePressed(MouseEvent e) { 
	if (box == null) {
	    box = new Box(e.getPoint(), e.getPoint(), wb);
	    box.addMouseListener(this);
	    box.addMouseMotionListener(this);
	    wb.add(box, -1);
	}
    }
    public void mouseReleased(MouseEvent e) { 
	if (box != null) {
	    handleMouseEvent(e);
	    wb.componentAdded(box, this);
	    box.removeMouseListener(this);
	    box.removeMouseMotionListener(this);
	    box.addPropertyChangeListener(new PropListener(wb, box));
	    box.setConstructed(true);
	    box = null;
	}
    }

    public void mouseClicked(MouseEvent e) { 
    }
    public void mouseEntered(MouseEvent e) { 
	if (box != null)
	    handleMouseEvent(e);
    }
    public void mouseExited(MouseEvent e) { 
    }
    public void mouseMoved(MouseEvent e) { 
    }
    public void mouseDragged(MouseEvent e) { 
	if (box != null) {
	    handleMouseEvent(e);
	}
    }

    public Cursor getPreferredCursor() {
	return null;
    }

}



