package sieve.whiteboard;

import java.awt.*;
import java.awt.event.*;
import sieve.workbench.*;

/**
 * Tool for constructing a Freehand "doodle" object.
 */
public class DoodleTool implements Tool {
    Workbench wb = null;
    Doodle doodle = null;

    public DoodleTool(Workbench wb) {
	this.wb = wb;
    }

    public DoodleTool() { }

    public void init(Workbench wb, Class cl) {
	this.wb = wb;
    }

    private void handleMouseEvent(MouseEvent e) {
	if (doodle != null) {
	    doodle.addPoint(e.getPoint());
	    doodle.setBounds(doodle.getBounds());
	    doodle.repaint();
	}
    }

    public void mousePressed(MouseEvent e) { 
	if (doodle == null) {
	    doodle = new Doodle(e.getPoint(), wb);
	    doodle.addMouseListener(this);
	    doodle.addMouseMotionListener(this);
	    wb.add(doodle, -1);
	}
    }
    public void mouseReleased(MouseEvent e) { 
	if (doodle != null) {
	    handleMouseEvent(e);
	    wb.componentAdded(doodle, this);
	    doodle.removeMouseListener(this);
	    doodle.removeMouseMotionListener(this);
	    doodle.addPropertyChangeListener(new PropListener(wb, doodle));
	    doodle.setConstructed(true);
	    doodle = null;
	}
    }

    public void mouseClicked(MouseEvent e) { }
    public void mouseEntered(MouseEvent e) { 
	if (doodle != null)
	    handleMouseEvent(e);
    }
    public void mouseExited(MouseEvent e) { }
    public void mouseMoved(MouseEvent e) { }
    public void mouseDragged(MouseEvent e) { 
	if (doodle != null) {
	    handleMouseEvent(e);
	}
    }

    public Cursor getPreferredCursor() {
	return null;
    }

}



