package sieve.whiteboard;

import java.beans.*;

public class HorizontalAlignmentEditor extends PropertyEditorSupport {

    public String getJavaInitializationString() {
	HorizontalAlignment value = (HorizontalAlignment) getValue();
	if (value.isLeft())
	    return("Left");
	else if (value.isRight())
	    return("Right");
	else
	    return("Center");
    }

    public String getAsText() {
	return getJavaInitializationString();
    }

    public void setAsText(String text) throws IllegalArgumentException{
	if (text.toLowerCase().equals("left")) 
            setValue(new HorizontalAlignment(HorizontalAlignment.ALIGN_LEFT));
	else if (text.toLowerCase().equals("right")) 
            setValue(new HorizontalAlignment(HorizontalAlignment.ALIGN_RIGHT));
	else if (text.toLowerCase().equals("center")) 
            setValue(new HorizontalAlignment(HorizontalAlignment.ALIGN_CENTER));
        else 
            throw new IllegalArgumentException(text);
    }

    public String[] getTags() {
        String result[] = { "Left", "Center", "Right" };
        return result;
    }

}

