package sieve.whiteboard;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
//import com.sun.java.swing.*; // JTextArea isn't lightweight !?!?!

public class PostItNote extends TextArea implements KeyListener, Runnable {
    PropertyChangeSupport support = new PropertyChangeSupport(this);
    Dimension mySize = null;

    long wakeUpTime = 0;

    public PostItNote() {
	mySize = new Dimension(200, 200);
	addKeyListener(this);
	// Nobody likes the PostIt-colored background :-(
	// setBackground(new Color(255, 255, 108));
	Thread life = new Thread(this);
	life.setDaemon(true);
	life.start();
    }

    public synchronized void run() {
	while (true) {
	    setEditable(System.currentTimeMillis() > wakeUpTime);
	    try {
		if (isEditable())
		    wait();
		else
	            wait((long)Math.max(0, wakeUpTime - 
		        System.currentTimeMillis()));
	    }
	    catch(InterruptedException e) { }
	}
    }

    public void setText(String text) {
	wakeUpTime = System.currentTimeMillis() + 5000;
	synchronized(this) {
	    notifyAll();
	}
	super.setText(text);
    }

    public String getText() {
	return super.getText();
    }

    // ------------- KeyListener methods -------------
    public void keyTyped(KeyEvent e) {
	support.firePropertyChange("text", null, getText());
    }
    public void keyPressed(KeyEvent e) { }
    public void keyReleased(KeyEvent e) { }

    public void addPropertyChangeListener(PropertyChangeListener listener) {
        support.addPropertyChangeListener(listener);
    }
 
    public void removePropertyChangeListener(PropertyChangeListener listener) {
        support.removePropertyChangeListener(listener);
    }

    public void setSize(Dimension size) {
	if ((size.width != 0) && (size.height != 0)) 
            this.mySize = size;
        super.setSize(size);
    }
    public void setSize(int w, int h) {
	if ((w != 0) && (h != 0)) 
            this.mySize = new Dimension(w, h);
        super.setSize(w, h);
	
    }
    public void setBounds(int x, int y, int w, int h) {
	if ((w != 0) && (h != 0)) 
            this.mySize = new Dimension(w, h);
        super.setBounds(x, y, w, h);
    }
    public void setBounds(Rectangle r) {
	if ((r.width != 0) && (r.height != 0)) 
            this.mySize = new Dimension(r.width, r.height);
        super.setBounds(r);
    }
    public Dimension getMinimumSize() {
        return mySize;
    }
    public Dimension minimumSize() {
        return mySize;
    }
    public Dimension preferredSize() {
        return mySize;
    }
    public Dimension getPreferredSize() {
        return mySize;
    }
}

