package sieve.whiteboard; 

import java.awt.*;
import java.awt.image.*;
import java.net.*;

public class URLImage extends Component implements ImageObserver {
    Image image = null;
    String url = "";

    public URLImage() {
	setURL("http://linc.cs.vt.edu/images/linc.gif");
    }

    public void setURL(String url) {
	try {
	    image = Toolkit.getDefaultToolkit().getImage(new URL(url));
	    this.url = url;
	}
	catch (Exception e) {
	    e.printStackTrace();
	}
    }

    public String getURL() {
	return url;
    }

    public void paint(Graphics g) {
	if (image != null) {
	    g.drawImage(image, 0, 0, this);
	}
    }

    private Dimension imageSize() {
	if (image == null)
	    return new Dimension(200, 100);
	else {
	    return new Dimension( image.getWidth(this), image.getHeight(this));
	}
    }

    public Dimension getMinimumSize() {
	return imageSize();
    }

    public Dimension getPreferredSize() {
	return imageSize();
    }

    public boolean imageUpdate(Image img, int infoflags, int x, int y, 
	int width, int height) {
	repaint();
	return true;
    }

}

