package sieve.whiteboard;

import java.awt.*;

public abstract class WhiteBoardComponent extends Component 
    implements sieve.quarry.Stretchable
    {
    Dimension 	size		= new Dimension(100, 100);
    Color	lineColor 	= null;
    int		lineThickness 	= 1;

    public WhiteBoardComponent() {
	lineColor = getForeground();
	if (lineColor == null)
	    lineColor = Color.black;
    }

    public int getLineThickness() {
	return lineThickness;
    }

    public void setLineThickness(int lineThickness) {
	if (lineThickness != this.lineThickness) {
	    this.lineThickness = lineThickness;
	    repaint();
	}
    }

    public void setLineColor(Color lineColor) {
	if (lineColor != this.lineColor) {
	    this.lineColor = lineColor;
	    repaint();
	}
    }
    public Color getLineColor() {
	return lineColor;
    }

    public void update(Graphics g) {
	paint(g);
    }

    public abstract void paint(Graphics g); 

    /* ---- Overriding these to make it stretch properly... --- */
    public void setSize(Dimension size) {
        this.size = size;
        super.setSize(size);
    }
    public void setSize(int w, int h) {
        this.size = new Dimension(w, h);
        super.setSize(size);
    }
    public void setBounds(int x, int y, int w, int h) {
        this.size = new Dimension(w, h);
        super.setBounds(x, y, w, h);
    }
    public void setBounds(Rectangle r) {
        this.size = new Dimension(r.width, r.height);
        super.setBounds(r);
    }

    public Dimension getMinimumSize() {
        return size;
    }
    public Dimension minimumSize() {
        return size;
    }
    public Dimension preferredSize() {
        return size;
    }
    public Dimension getPreferredSize() {
        return size;
    }

}

