package sieve.whiteboard;


import java.awt.*;

import vt.cs.widgets.*;

public class WhiteBoardScaler extends Scaler {

    public WhiteBoardScaler() {
	super(null);
    }

    public void paintScaled(Graphics g, Dimension size) {
	// Ignore this...
    }

//System.out.println("scale: " + scaleBounds + " full: " + fullBounds + " comp: " + compBounds);

    public void paintComponent(Graphics g, Component c, Rectangle scaleBounds, 
	Rectangle fullBounds) {

	g.setColor(Color.black);

	if (c instanceof RectangularComponent) {
	    RectangularComponent rc = (RectangularComponent) c;
	    Point start = rc.getStart();
	    Point end = rc.getEnd();
            Rectangle compBounds = scaleRectangle(
		new Rectangle(Math.min(start.x, end.x),
		    Math.min(start.y, end.y),
		    Math.abs(start.x - end.x),
		    Math.abs(start.y - end.y)),
                new Dimension(scaleBounds.width, scaleBounds.height),
                new Dimension(fullBounds.width, fullBounds.height));

	    if (c instanceof Box) {
	        if (((Box)c).isFilled())
         	    g.fillRect(compBounds.x, compBounds.y, compBounds.width,
            	        compBounds.height);
	        else
         	    g.drawRect(compBounds.x, compBounds.y, compBounds.width,
            	        compBounds.height);
	    }
	    else if (c instanceof Oval) {
	        if (((Oval)c).isFilled())
         	    g.fillOval(compBounds.x, compBounds.y, compBounds.width,
            	        compBounds.height);
	        else
         	    g.drawOval(compBounds.x, compBounds.y, compBounds.width,
            	        compBounds.height);
	    }
	}
	else if (c instanceof Line) {
	    Line l = (Line) c;
	    Point start = scalePoint(l.getStart(),
		new Dimension(scaleBounds.width, scaleBounds.height),
                new Dimension(fullBounds.width, fullBounds.height));
	    Point end = scalePoint(l.getEnd(),
		new Dimension(scaleBounds.width, scaleBounds.height),
                new Dimension(fullBounds.width, fullBounds.height));
	    g.drawLine(start.x, start.y, end.x, end.y);
	}
    }
}



