/*  
 * $Id: SharedDocument.java,v 1.2 1998/01/02 20:51:54 isenhour Exp $
 *
 * Copyright (c) 1997 James Begole,  All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * James Begole MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. James Begole 
 * SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package sieve.whiteboard.text;

import java.io.*;
import java.util.*;

import com.sun.java.swing.*;
import com.sun.java.swing.text.*;
import com.sun.java.swing.event.*;

/**
 *
 * @version 	$Revision: 1.2 $
 * @author James "Bo" Begole
 */

public class SharedDocument extends com.sun.java.swing.text.PlainDocument {
  private Vector listeners = null;

  public SharedDocument() {
    super();
    listeners = new Vector();
  }

  public SharedDocument(PlainDocument doc) {
    try {
      int contentLength = doc.getLength();
      insertString(0, doc.getText(0, contentLength), null /*AttributeSet*/);
    } catch (BadLocationException ble) {
      System.out.println("Error initializing content of SharedDocument: "+ble);
      ble.printStackTrace();
    }
  }

  public void addSharedDocumentListener(SharedDocumentListener sdl) {
    listeners.addElement(sdl);
  }

  public void removeSharedDocumentListener(SharedDocumentListener sdl) {
    listeners.removeElement(sdl);
  }

  private void notifyListeners(String command) {
    Vector tmp = (Vector) listeners.clone();
    for (Enumeration e = tmp.elements(); e.hasMoreElements();)
      ((SharedDocumentListener)e.nextElement()).processCommand(command);
  }

  public void insertString(int offs, String str, AttributeSet a) 
    throws BadLocationException {
    //    System.out.println("NoteDoc.insertString( "+offs+", "+str+", "+a+" )");
    System.out.println("SharedDocument.insertString()");
    notifyListeners("insert|" + offs + "|" + str);
    remoteInsertString(offs, str, a);
  }
  
  public void remoteInsertString(int offs, String str, AttributeSet a) 
    throws BadLocationException {
    System.out.println("SharedDocument.remoteInsertString("+offs+", "+str+", "+a+" )");
    super.insertString(offs, str, a);
  }

  public void remove(int offs, int len) 
    throws BadLocationException {
    System.out.println("SharedDocument.remove()");
    notifyListeners("remove|" + offs + "|" + len);
    remoteRemove(offs, len);
  }
  
  public void remoteRemove(int offs, int len) 
    throws BadLocationException {
     System.out.println("SharedDocument.remoteRemove("+offs+", "+len+")");
   super.remove(offs, len);
  }




  // --- serialization ---------------------------------------------
  /*
  private void writeObject(ObjectOutputStream s) throws IOException { 
    super.writeObject(s); 
  } 

  private void readObject(ObjectInputStream s) 
    throws ClassNotFoundException, IOException  
  { 
    super.readObject(s);
  } 
  */ 

}
