package sieve.workbench;

import java.awt.*;
import java.util.*;
import java.beans.*;
import com.sun.java.swing.*;

/**
 * A basic BeanBox-style property editor.
 */
public class DefaultPropertyEditor extends JTabbedPane implements
    WorkbenchComponentEditor {

    private Workbench wb = null;
    private PropertyPanel p = null;
    private Hashtable cache = null;
    private Customizer customizer = null;
    private String name = null;

    public DefaultPropertyEditor() {
	cache = new Hashtable();
    }

    public DefaultPropertyEditor(Workbench wb) {
	cache = new Hashtable();
	setWorkbench(wb);
    }

    public void setWorkbench(Workbench wb) {
	this.wb = wb;
    }

    public String getTargetName() {
	return name;
    }

    public void setTarget(WorkbenchComponent wbc) {
	int tabs = getTabCount();
	for (int t = 0; t < tabs; t++) 
	    removeTabAt(0);
	if ((wbc == null) || (wb == null))
            return;
	setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
	try {
	    BeanInfo bi = Introspector.getBeanInfo(
		wbc.getModel().getClass());
	    BeanDescriptor bd = bi.getBeanDescriptor();
	    name = bd.getDisplayName();
	    if (wbc.getModel() instanceof Component) {
	        Class cl = bd.getCustomizerClass();
	        if (cl != null) {
		    customizer = (Customizer) cl.newInstance();
		    customizer.setObject(wbc.getModel());
		    ScrollPane sp = 
			new ScrollPane(ScrollPane.SCROLLBARS_ALWAYS);
		    sp.add((Component)customizer);
		    addTab("Customizer", sp);
	        }
	    }
        }
	catch (Exception ex) {
	    ex.printStackTrace();
            return;
        }

	p = (PropertyPanel) cache.get(wbc);
	if (p == null) {
	    p = new PropertyPanel(wbc.getModel(), wbc, wb);
	    cache.put(wbc, p);
	}
	ScrollPane jsp = new ScrollPane(ScrollPane.SCROLLBARS_ALWAYS);
	jsp.add(p);
	addTab("Properties", jsp);
	setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    }
}

