package sieve.workbench;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import sieve.workbench.event.*;
import sieve.workbench.collab.*;

import vt.cs.widgets.*;

import SharedData.*;

public class Test extends Applet {
    public static final String SESSION_NAME = "Test Session";
    public static final String CHANNEL_NAME = "Test Channel";

    Workbench wb = null;
    RadarPane scroller =  null;
    WorkbenchChannelManager mgr = null;
    String host = null;

    CollaborationSupport cs = null;

    private void showInFrame() {
	Frame f = new Frame("Workbench Test");
	f.setLayout(new BorderLayout());
	f.setSize(new Dimension(400, 600));
	f.add("Center", scroller);
	f.show();
	cs.restoreWorkbench();
    }

    public void init() {
	setLayout(new BorderLayout());
	add("Center", scroller);
	cs.restoreWorkbench();
    }

    private Controller getController() {
	Workbench mirror = new Workbench();
        Controller controller = new Controller(mirror);
        Frame f = new Frame("Mirror");
        f.setLayout(new BorderLayout());
        f.setSize(new Dimension(400, 600));
        f.add("Center", mirror);
        f.show();
	return controller;
    }

    public Test() {
	this(null);
    }
    public Test(String host) {
	wb = new Workbench();
	wb.setSize(new Dimension(1000, 1000));
	wb.addKeyListener(new WorkbenchKeyListener(wb));

	PropPanelAdapter ed = new PropPanelAdapter(wb);
	wb.setWorkbenchComponentEditor(ed);
	Frame edFrame = new Frame("Editor");
	edFrame.setLayout(new BorderLayout());
	edFrame.add(ed);
	edFrame.pack();
	edFrame.show();

	edFrame = new Frame("ToolBox");
	edFrame.setLayout(new BorderLayout());
	edFrame.add(new ToolBox(100, 100, wb));
	edFrame.pack();
	edFrame.show();

	cs = new CollaborationSupport(wb, host, SESSION_NAME, 
	    CHANNEL_NAME, "Test User", Color.blue);
	scroller = cs.getRadarPane();
	scroller.setScaler(new WorkbenchScaler(wb));
    }


    public static void main(String[] args) {
      //	System.setSecurityManager(new TestSecurityManager());
	Test t = null;
	String host = null;
	if (args.length > 0) 
	    host = args[0];
	
	t = new Test(host);
	t.showInFrame();
    }

    private class PropPanelAdapter extends ScrollPane implements 
	WorkbenchComponentEditor {
	PropertyPanel p = null;
	Hashtable cache = new Hashtable();
	Workbench wb = null;

	public PropPanelAdapter(Workbench wb) {
	    setSize(new Dimension(100, 100));
	    this.wb = wb;
	}
 	public void setTarget(WorkbenchComponent wbc) {
	    if (p != null)
		remove(p);
	    if (wbc == null)
		return;
	    setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
	    p = (PropertyPanel) cache.get(wbc);
	    if (p == null) {
	        p = new PropertyPanel(wbc.getModel(), wbc, wb);    
		cache.put(wbc, p);
	    }
	    addImpl(p, null, 0);
            p.doLayout();
            setScrollPosition(0, 0);
            invalidate();
            doLayout();
	    setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
	}

    }

    class WorkbenchKeyListener extends KeyAdapter {
        private Workbench wb = null;
        public WorkbenchKeyListener(Workbench wb) {
            this.wb = wb;
        }
        public void keyReleased(KeyEvent evt) {
            if (evt.getKeyCode() == KeyEvent.VK_DELETE) {
                WorkbenchComponent wbc = wb.getCurrentSelection();
                if (wbc != null)
                    wbc.remove();
            }
        }
    }
}

