package sieve.workbench;

import java.beans.*;
import java.awt.*;
import java.io.*;
import java.util.Vector;
import java.awt.event.*;
import java.util.*;
import java.lang.reflect.*;
import sieve.workbench.event.*;
import sieve.workbench.jar.*;


// For now I'm adding the toolbox panel that we used for the LiNC demos.
// This needs to be upgraded in various ways. You should be able to load
// jar files into it. We should also consider if/how we want to support 
// icons in the new panel.
// Mostly it has just become very, very ugly...
public class ToolBox extends Panel {
    private Workbench	 tu;
    private DemoToolPanel	list = null;

    static boolean loadHardCodedToolsets = false;

    public static void setLoadHardCodedToolsets(boolean set) {
	loadHardCodedToolsets = set;
    }

    public ToolBox(int x, int y, Workbench tu) {
	this.tu = tu;

	setBackground(Color.lightGray);
	setLayout(new BorderLayout());
	list = new DemoToolPanel(tu);
	add("Center", list);
	setSize(new Dimension(400, 400));
    }

    public void addJarFile(String fileName) {
	list.addJarFile(fileName);
    }

    public void addToolSet(ToolSet ts) {
	list.addToolSet(ts);
    }

}


class DemoToolPanel extends Panel {
    ListPanel listPanel = null;
    Workbench tu = null;

    public DemoToolPanel(Workbench tu) {
      this.tu = tu;
      setLayout(new BorderLayout());
      listPanel = new ListPanel(this, tu);
      add("Center", listPanel);
	
      if (ToolBox.loadHardCodedToolsets) {
	DefaultToolSet simulations = new DefaultToolSet("Simulations");
	simulations.addBeanClass("sieve.phys.lwblockandplane.BlockAndPlane");
	simulations.addBeanClass("sieve.phys.blockandplane.BlockAndPlane");

	DefaultToolSet whiteboard = new DefaultToolSet("Annotation Tools");
	whiteboard.addBeanClass("sieve.whiteboard.Line");
	whiteboard.addBeanClass("sieve.whiteboard.Box");
	whiteboard.addBeanClass("sieve.whiteboard.Oval");
	whiteboard.addBeanClass("sieve.whiteboard.Doodle");
	whiteboard.addBeanClass("sieve.whiteboard.PostItNote");
	whiteboard.addBeanClass("sieve.whiteboard.URLImage");
	whiteboard.addBeanClass("sieve.whiteboard.text.SharedTextWrapper");

	DefaultToolSet selectors = new DefaultToolSet("Filters");
	selectors.addBeanClass("sieve.sluice.views.TableSelectionView");
	selectors.addBeanClass("sieve.sluice.views.FrequencyTableView");
	selectors.addBeanClass("sieve.sluice.views.CriteriaView");
	selectors.addBeanClass("sieve.sluice.views.FieldNameSelectionView");
	selectors.addBeanClass("sieve.sluice.views.FieldXYView");
	selectors.addBeanClass("sieve.sluice.views.ColorChangeView");
	selectors.addBeanClass("sieve.sluice.views.PolyInterpolatedView");

	DefaultToolSet viewers = new DefaultToolSet("Visualizations");
	viewers.addBeanClass("sieve.nuggets.RegressionPlot");
	viewers.addBeanClass("sieve.nuggets.EditableRegressionPlot");
	viewers.addBeanClass("sieve.nuggets.LineGraph.LineGraph");
	viewers.addBeanClass("sieve.nuggets.TextTable");
	viewers.addBeanClass("sieve.nuggets.SwingTable");
	viewers.addBeanClass("sieve.nuggets.AttributeViewer");
	viewers.addBeanClass("sieve.nuggets.BarChart");
	viewers.addBeanClass("sieve.nuggets.NewBarChart");
	viewers.addBeanClass("sieve.nuggets.Histogram");
	viewers.addBeanClass("sieve.nuggets.Graph");

	DefaultToolSet other = new DefaultToolSet("Other Tools");
	other.addBeanClass("sieve.sluice.views.CacheView");
	other.addBeanClass("sieve.sluice.weblog.CachedWebLogReader");
	other.addBeanClass("sieve.browser.Browser");
	other.addBeanClass("sieve.beanbox.PropertyBinder");
	other.addBeanClass("sieve.beanbox.EventAdapter");
	other.addBeanClass("sieve.whiteboard.text.SharedTextWrapper");

	DefaultToolSet sosci = new DefaultToolSet("SocSci Tools");
	sosci.addBeanClass("sieve.sluice.codebook.SGMLTable");
	sosci.addBeanClass("sieve.sluice.codebook.CachedSGMLTable");
	sosci.addBeanClass("sieve.nuggets.StretchableHistogram");

	sieve.phys.circuit.PaletteToolSet circuit = new
	    sieve.phys.circuit.PaletteToolSet();
/*
	DefaultToolSet circuit = new DefaultToolSet("Circuit Components");
	//circuit.addBeanClass("sieve.phys.circuit.CircuitComponent");
	circuit.addBeanClass("sieve.phys.circuit.Battery");
	circuit.addBeanClass("sieve.phys.circuit.Resistor");
	circuit.addBeanClass("sieve.phys.circuit.Ammeter");
	circuit.addBeanClass("sieve.phys.circuit.Voltmeter");
	circuit.addBeanClass("sieve.phys.circuit.LightBulb");
	circuit.addBeanClass("sieve.phys.circuit.Terminal");
	circuit.addBeanClass("sieve.phys.circuit.Palette");
*/

	DefaultToolSet symphony = new DefaultToolSet("Symphony");
	symphony.addBeanClass("symphony.beans.file.File");
	symphony.addBeanClass("symphony.beans.stdin.StdInput");
	symphony.addBeanClass("symphony.beans.stdout.StdOutput");
	symphony.addBeanClass("symphony.beans.program.Program");

	listPanel.addToolSet(symphony);
	listPanel.addToolSet(sosci);
	listPanel.addToolSet(simulations);
	listPanel.addToolSet(circuit);
	listPanel.addToolSet(selectors);
	listPanel.addToolSet(viewers);
	listPanel.addToolSet(whiteboard);
	listPanel.addToolSet(other);

	//listPanel.selectToolSet("SocSci Tools");
	listPanel.selectToolSet("Symphony");
	//listPanel.selectToolSet("Simulations");
	//listPanel.selectTool(0);
      }
    }

    public void addJarFile(String fileName) {
	listPanel.addToolSet(new DefaultToolSet(fileName));
    }

    public void addToolSet(ToolSet ts) {
	listPanel.addToolSet(ts);
    }
    
}

class ListPanel extends Panel implements ToolListener {
    DemoToolPanel toolPanel = null;
    Hashtable setMap = null;
    Hashtable setIdxMap = null;
    String lastSet = null;
    int lastTool = -1;
    String currentTool = null;

    List sets = null;
    List tools = null;

    Workbench tu = null;

    public ListPanel(DemoToolPanel toolPanel, Workbench tu) {
	this.toolPanel = toolPanel;
	this.tu = tu;
	setLayout(new GridLayout(1, 2, 2, 2));
	sets = new List();
	sets.addItemListener(new SetListListener(this));
	tools = new List();
	ToolListListener toolListListener = new ToolListListener(this);
	tools.addItemListener(toolListListener);
	add(sets);
	add(tools);
	setMap = new Hashtable();
	setIdxMap = new Hashtable();
	tu.addToolListener(this);
    }

    public void addToolSet(ToolSet ts) {
	setMap.put(ts.getName(), ts);
	setIdxMap.put(ts.getName(), new Integer(sets.getItemCount()));
	sets.add(ts.getName());
    }

    public synchronized void selectToolSet(String setName) {
	ToolSet ts = (ToolSet)setMap.get(setName);

	if (setName.equals(lastSet))
	    return;

	if (ts != null ) {
	    lastSet = setName;
	    int idx = ((Integer)setIdxMap.get(setName)).intValue();
	    if (idx != sets.getSelectedIndex())
		sets.select(idx);
	    String[] toolNames = ts.getLabels();
	    tools.removeAll();
	    for (int t = 0; t < toolNames.length; t++)
		tools.addItem(toolNames[t]);
	    tu.setCurrentTool(null);
	    lastTool = -1;
	}
    }

    public synchronized void selectToolSet(int idx) {
	selectToolSet(sets.getItem(idx));
    }

    public synchronized void selectTool(int idx) {
	if (idx == lastTool) {
	    tu.setCurrentTool(null);
	    tools.deselect(idx);
	    lastTool = -1;
	}
	else {
	    lastTool = idx;
	    currentTool = tools.getItem(idx);
 
	    // Find the current tool
	    ToolSet ts = (ToolSet)setMap.get(lastSet);
	    ts.selectTool(currentTool, tu);
	}
    }

    // ---------- ToolListener interface ----------
    public void toolChanged(ToolEvent e) {
	if ((e.getCurrentTool() == null) && (lastTool != -1)) {
	    int tmp = lastTool;
	    lastTool = -1;
	    tools.deselect(tmp);
	}
    }
    public void toolUsed(ToolEvent e) {}
    public void toolRetainedStateChanged(ToolEvent e) {}
}


class SetListListener implements ItemListener {
    ListPanel listPanel = null;

    public SetListListener(ListPanel listPanel) {
	this.listPanel = listPanel;
    }

    public void itemStateChanged(ItemEvent e) {
	if (e.getStateChange() == ItemEvent.SELECTED) {
	    listPanel.selectToolSet(((Integer)e.getItem()).intValue());
	}
    }
}

class ToolListListener implements ItemListener {
    ListPanel listPanel = null;

    public ToolListListener(ListPanel listPanel) {
	this.listPanel = listPanel;
    }

    public void itemStateChanged(ItemEvent e) {
	if (e.getStateChange() == ItemEvent.SELECTED) 
	    listPanel.selectTool(((Integer)e.getItem()).intValue());
    }
}

// A set of tools, e.g., visualizations, filters, or simulations
class DefaultToolSet implements ToolSet {
    Vector beanLabels = new Vector();
    Vector beanNames = new Vector();
    Vector beanIcons = new Vector();
    Hashtable labelMap = new Hashtable();
    String name = null;

    private JarInfo jarInfo = null;
    private JarLoader jarLoader = null;

    public DefaultToolSet(String jar) {
	this.name = jar;
	try {
	    jarLoader = new JarLoader(jar);
	    jarInfo = jarLoader.loadJar();
	    String beans[] = jarInfo.getBeanNames();
	    for(int i = 0; i < beans.length; i++) {
	        addBean(jarInfo.getBeanInfo(i), beans[i]);
	    }
	    File tmpFile = new File(jar);
	    name = tmpFile.getName();
	    name = name.substring(0, name.lastIndexOf(".jar"));
	}
	catch(java.io.FileNotFoundException e) { }
    }

    public void selectTool(String toolToSelect, Workbench wb) {
	Tool t = ToolFactory.getToolFactory().getTool(
	    getClassLabeled(toolToSelect), wb);
	wb.setCurrentTool(t);
    }

    public String getName() {
	return name;
    }

    public String[] getLabels() {
	String[] labels = new String[beanLabels.size()];
	beanLabels.copyInto(labels);
	return labels;
    }

    public void addBeanClass(String beanClassName) {
        Class beanClass;
        try {
            beanClass = Class.forName(beanClassName);
        } catch (Exception ex) {
            System.err.println("Toolbox: couldn't instantiate " +
                                                             beanClassName);
ex.printStackTrace();
            return;
        }
        BeanInfo bi;
        try {
            bi = Introspector.getBeanInfo(beanClass);
        } catch (Exception ex) {
            System.err.println("Toolbox: couldn't find BeanInfo for " +
                                                                beanClassName);
            ex.printStackTrace();
            return;
        }
	addBean(bi, beanClassName);
    }

    private void addBean(BeanInfo bi, String beanClassName) {
	if ((bi != null) && (beanClassName != null)) {
            String label = bi.getBeanDescriptor().getDisplayName();
            label = getUniqueName(beanLabels, label);
	    beanLabels.addElement(label);

            Image img = bi.getIcon(BeanInfo.ICON_COLOR_16x16);
	    labelMap.put(label, beanClassName);
            beanNames.addElement(beanClassName);
            beanIcons.addElement(img);
	}
    }

    public synchronized Class getClassLabeled(String label) {
	String beanName = (String)labelMap.get(label);
	if (beanName != null) {
            try {
	        if (jarInfo != null) {
		    return jarLoader.getLoader().loadClass(beanName);
	        }
	        else {
                   Class cl = Class.forName(beanName);
		   return cl;
                }  
	    }
	    catch (Exception exe) {
	 	exe.printStackTrace();
            }
	}
	return null;
    }

    String getUniqueName(Vector v, String s) {
        if (! v.contains(s)) {
            return s;
        }
        int count = 2;
        while (v.contains(s+"<"+count+">")) {
            count += 1;
        }
	return s+"<"+count+">";
    }
}

