/**
 * This interface is used by the default (hierarchical) ToolBox. ToolSets 
 * are things that show up in the left column of the toolbox.
 */
package sieve.workbench;

public interface ToolSet {
    /**
     * The name of the ToolSet.
     */
    public String getName();

    /**
     * The names of all of the tools in the ToolSet.
     */
    public String[] getLabels();

    /**
     * Select the specified tool. The parameter will be one of the tool
     * names returned by getLabels(). The toolset should construct an
     * appropriate Tool object and tell the workbench to use it.
     */
    public void selectTool(String toolName, Workbench wb);
}



