package sieve.workbench.collab;

import sieve.workbench.*;
import sieve.workbench.collab.msg.*;

/**
 * A ChannelRecorder records interesting events on Workbench channel. 
 * It must look like a WorkbenchController and must also provide means
 * for retrieving the Recorded messages. Implementations of this interface
 * should also be Serializable.
 */
public interface ChannelRecorder extends WorkbenchController {
    /**
     * Returns the name associated with this recorder.
     */
    public String getName();

    /**
     * Returns the current number of stored messages.
     */
    public int getMessageCount();

    /**
     * Returns an array of messages which, if replayed, would reproduce
     * the state of the workbench.
     */
    public Message[] getMessages();
}

