package sieve.workbench.collab; 

import sieve.workbench.collab.msg.Message;


/**
 * LocalRecorderClient is a message-passer from the workbench's "local"
 * Broadcaster to the ChannelRecorder which is recording the local
 * session. Initial motivation for this arrangement was to duplicate the 
 * saving of the collaborative sessions to make this feature available
 * in single-user mode as well.
 */
public class LocalRecorderClient implements WorkbenchClient {

	ChannelRecorder cr = null;

	public LocalRecorderClient(ChannelRecorder rec) {
		cr = rec;
	}

	public LocalRecorderClient() {
		String sessionName = "sieve_" + Long.toString( System.currentTimeMillis() );
		cr = new MinimalReplayRecorder(sessionName);
	}

    public void send(Message m){
		m.deliver(cr);		
	}

	public ChannelRecorder getRecorder() {
		return cr;
	}

}
