package sieve.workbench.collab;


/**
 * Non-remote subset of ServerListener for users of WorkbenchChannelManager.
 * Each ChannelManager corresponds to a session. Listeners are notified
 * when channels within that session are added or removed.
 *
 * @see ServerListener
 */
public interface WorkbenchChannelListener extends java.util.EventListener {
    /**
     * Called when a channel is added.
     */
    public void channelAdded(WorkbenchChannelEvent e);

    /**
     * Called when a channel is removed.
     */
    public void channelRemoved(WorkbenchChannelEvent e);

}

