package sieve.workbench.collab;

import java.util.*;
import java.beans.*;
import java.awt.*;
import java.awt.event.*;
import sieve.workbench.*;
import sieve.workbench.event.*;
import java.io.Serializable;

/**
 * WorkbenchControllers are things that look like users of a workbench. This
 * interface will initially be implemented by the "Controller" class (which
 * processes incoming events for using Sieve in collaborative mode) and
 * by the server which implements state persistence (?). All methods would
 * typically be synchronized.
 */
public interface WorkbenchController {

    public void doAddComponent(String className, MouseEvent[] evts, 
	UniqueID id);

    public void doRemoveComponent(UniqueID id);

    public void doSetBounds(UniqueID id, Rectangle b);

    public void doMakeLink(String linkClassName, UniqueID srcID, 
	UniqueID destID, UniqueID linkID, Serializable state);

    public void doRemoveLink(UniqueID linkID);

    public void doEditComponent(UniqueID objID, EditEvent e);

}


