package sieve.workbench.event;

import sieve.workbench.WorkbenchComponent;

/**
 * Interface for objects which can approve or reject selection requests.
 * Note that we deviate from the normal event listener interface somewhat.
 * This interface may eventually need to evolve to support other 
 * "policy" decisions besides selection.
 */
public interface SelectionListener {

    /**
     * Returns true if this listener approves of allowing the specified
     * component to be selected for editing.
     */
    public boolean selectionApproved(WorkbenchComponent c);

}

