package sieve.workbench.event;

import sieve.workbench.*;
import java.util.*;

/**
 * Utility class for use by the Workbench to handle registration and 
 * notification of SelectionListeners. 
 */
public class SelectionListenerSupport {
    private Workbench source = null;
    private Vector listeners = new Vector();

    public SelectionListenerSupport(Workbench source) {
	this.source = source;
    }

    public synchronized void addSelectionListener(SelectionListener tl) {
	listeners.addElement(tl);
    }

    public synchronized void removeSelectionListener(SelectionListener tl) {
	listeners.removeElement(tl);
    }

    public boolean selectionApproved(WorkbenchComponent c) {
	Vector targets;
	synchronized(this) {
	    targets = (Vector)listeners.clone();
	}
	boolean approved = true;
	for (int i = 0; i < targets.size() && approved; i++) {
	    approved = approved &&
	        ((SelectionListener)targets.elementAt(i)).selectionApproved(c);
	}
	return approved;
    }

}



