
package sieve.crew;

import SharedData.*;

/**
 * This is just a simple server/client based proof-of-concept
 * implementation to make sure that the Shared Data classes have
 * all the required API in them.
 *
 * It's based on the chat demonstration which is part of the
 * west-coast rmi distribution.
 *
 * @version     0.90 11 February 1997
 * @author      Rich Burridge, James Begole
 */

public class Server {


  private static final int  defaultPort = sieve.quarry.QuarryBox.defaultPort;
  private static final String defaultHost = sieve.quarry.QuarryBox.defaultHost;
  private static final String defaultSessionName = sieve.quarry.QuarryBox.defaultSessionName;

    private static String sessionName = defaultSessionName;

    public static void  main(String args[]) {
	Session    session = null;
	String     url         = null;
	String     sessionType = null;
	String     hostname    = null;
	int        hostport    = 0;


	debug("main");

        hostname    = getHost(args);
	hostport    = getPort(args);
	sessionType = getType(args);
	
	//url = "coll:simon.cs.vt.edu:"+hostport+"/socket/Session/Sieve";
	 
	url = "coll://" + hostname + ":" + hostport + "/" + sessionType +
	  "/Session/" + sessionName; 
	      

	try {
	  /* Create a session, [re]bind it and create a channel. */
	    session = SessionFactory.createSession(url);
	    session.createChannel(null, NuggetControl.ChannelName, true, true);
	    session.createChannel(null, ParticipantControl.ChannelName, true, true);
            System.out.println("Setup and bound server.");
        } catch (SharedDataException e) {
            System.out.println("Server: main: shared data exception: " + e);
	    e.printStackTrace();
        }
    }


  private static String getHost(String args[]) {
    debug("getHost()");
    String returnString = getArg("-server", args);
    if (returnString != null)
      return returnString;
    else
      return defaultHost;
  }


  private static int getPort(String args[]) {
    debug("getPort");
    String returnString = getArg("-port", args);
    debug("getPort got: "+returnString);
    if (returnString != null)
      return(Integer.parseInt(returnString));
    else
      return defaultPort;
  }


  private static String getType(String args[]) {
    debug("getType.");
    String returnString = getArg("-type", args);
    if (returnString != null)
      return returnString;
    else
      return "socket";
  }


  private static String getArg(String parameter, String args[]) {
    debug("getArg.");
    int length = args.length;
    for (int i = 0; i < length; i++) {
      if (args[i].equals(parameter)) {
	if (++i < length) {
	  return(args[i]);
	}
      }    
    }
    return null;
  }

  private static  final boolean debug = false;
  private static void debug(String msg) {
    if (debug)
      System.out.println("sieve.crew.Server: "+msg);
  }
}
